/********************************************************************************
 *                               libemu
 *
 *                    - x86 shellcode emulation -
 *
 *
 * Copyright (C) 2007  Paul Baecher & Markus Koetter
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 * 
 * 
 *             contact nepenthesdev@users.sourceforge.net  
 *
 *******************************************************************************/

#include <stdlib.h>
#include <string.h>

#include <emu/emu.h>
#include <emu/environment/win32/emu_env_w32_dll_export.h>
#include <emu/environment/win32/env_w32_dll_export_kernel32_hooks.h>
#include <emu/environment/win32/env_w32_dll_export_urlmon_hooks.h>
#include <emu/environment/win32/env_w32_dll_export_ws2_32_hooks.h>
#include <emu/environment/win32/env_w32_dll_export_msvcrt_hooks.h>


struct emu_env_w32_dll_export kernel32_exports[] = 
{
	{"ActivateActCtx", 0x0000A644, NULL, NULL},
	{"AddAtomA", 0x000354ED, NULL, NULL},
	{"AddAtomW", 0x000326C1, NULL, NULL},
	{"AddConsoleAliasA", 0x00070CBF, NULL, NULL},
	{"AddConsoleAliasW", 0x00070C81, NULL, NULL},
	{"AddLocalAlternateComputerNameA", 0x00058F26, NULL, NULL},
	{"AddLocalAlternateComputerNameW", 0x00058E0A, NULL, NULL},
	{"AddRefActCtx", 0x0002BF01, NULL, NULL},
	{"AddVectoredExceptionHandler", 0x00008F63, NULL, NULL},
	{"AllocConsole", 0x00071311, NULL, NULL},
	{"AllocateUserPhysicalPages", 0x0005E712, NULL, NULL},
	{"AreFileApisANSI", 0x0003594F, NULL, NULL},
	{"AssignProcessToJobObject", 0x0002E44A, NULL, NULL},
	{"AttachConsole", 0x000714F9, NULL, NULL},
	{"BackupRead", 0x00056DDF, NULL, NULL},
	{"BackupSeek", 0x00055EEF, NULL, NULL},
	{"BackupWrite", 0x000573FE, NULL, NULL},
	{"BaseCheckAppcompatCache", 0x000167D7, NULL, NULL},
	{"BaseCleanupAppcompatCache", 0x0006BE06, NULL, NULL},
	{"BaseCleanupAppcompatCacheSupport", 0x0006BE8A, NULL, NULL},
	{"BaseDumpAppcompatCache", 0x0006BCC1, NULL, NULL},
	{"BaseFlushAppcompatCache", 0x0006BC3F, NULL, NULL},
	{"BaseInitAppcompatCache", 0x000164CD, NULL, NULL},
	{"BaseInitAppcompatCacheSupport", 0x0002B38D, NULL, NULL},
	{"BaseProcessInitPostImport", 0x00017443, NULL, NULL},
	{"BaseQueryModuleData", 0x0003835A, NULL, NULL},
	{"BaseUpdateAppcompatCache", 0x00015120, NULL, NULL},
	{"BasepCheckWinSaferRestrictions", 0x00019805, NULL, NULL},
	{"Beep", 0x00037A77, NULL, NULL},
	{"BeginUpdateResourceA", 0x0006FC7B, NULL, NULL},
	{"BeginUpdateResourceW", 0x0006FAD8, NULL, NULL},
	{"BindIoCompletionCallback", 0x0002C02C, NULL, NULL},
	{"BuildCommDCBA", 0x0006AEED, NULL, NULL},
	{"BuildCommDCBAndTimeoutsA", 0x0006AEBF, NULL, NULL},
	{"BuildCommDCBAndTimeoutsW", 0x0006AF1F, NULL, NULL},
	{"BuildCommDCBW", 0x0006AF79, NULL, NULL},
	{"CallNamedPipeA", 0x0005FDCE, NULL, NULL},
	{"CallNamedPipeW", 0x0005FB7F, NULL, NULL},
	{"CancelDeviceWakeupRequest", 0x00060B97, NULL, NULL},
	{"CancelIo", 0x000300DA, NULL, NULL},
	{"CancelTimerQueueTimer", 0x00062DF0, NULL, NULL},
	{"CancelWaitableTimer", 0x0002CC09, NULL, NULL},
	{"ChangeTimerQueueTimer", 0x00012723, NULL, NULL},
	{"CheckNameLegalDOS8Dot3A", 0x00060A51, NULL, NULL},
	{"CheckNameLegalDOS8Dot3W", 0x00060811, NULL, NULL},
	{"CheckRemoteDebuggerPresent", 0x00059B1E, NULL, NULL},
	{"ClearCommBreak", 0x00066CF1, NULL, NULL},
	{"ClearCommError", 0x0006557C, NULL, NULL},
	{"CloseConsoleHandle", 0x0001DC7E, NULL, NULL},
	{"CloseHandle", 0x00009B47, env_w32_hook_CloseHandle, NULL},
	{"CloseProfileUserMapping", 0x0002C86D, NULL, NULL},
	{"CmdBatNotification", 0x0002F609, NULL, NULL},
	{"CommConfigDialogA", 0x00066871, NULL, NULL},
	{"CommConfigDialogW", 0x0006677D, NULL, NULL},
	{"CompareFileTime", 0x00010AD9, NULL, NULL},
	{"CompareStringA", 0x0000D077, NULL, NULL},
	{"CompareStringW", 0x0000A35E, NULL, NULL},
	{"ConnectNamedPipe", 0x0003145B, NULL, NULL},
	{"ConsoleMenuControl", 0x00071FBF, NULL, NULL},
	{"ContinueDebugEvent", 0x0005A565, NULL, NULL},
	{"ConvertDefaultLocale", 0x000383CF, NULL, NULL},
	{"ConvertFiberToThread", 0x0002FED7, NULL, NULL},
	{"ConvertThreadToFiber", 0x0002FF16, NULL, NULL},
	{"CopyFileA", 0x000286EE, NULL, NULL},
	{"CopyFileExA", 0x0005E3C4, NULL, NULL},
	{"CopyFileExW", 0x00027B32, NULL, NULL},
	{"CopyFileW", 0x0002F873, NULL, NULL},
	{"CopyLZFile", 0x000593AE, NULL, NULL},
	{"CreateActCtxA", 0x0006B7A5, NULL, NULL},
	{"CreateActCtxW", 0x0001545C, NULL, NULL},
	{"CreateConsoleScreenBuffer", 0x00073068, NULL, NULL},
	{"CreateDirectoryA", 0x000217AC, NULL, NULL},
	{"CreateDirectoryExA", 0x0005B23B, NULL, NULL},
	{"CreateDirectoryExW", 0x0005A5F2, NULL, NULL},
	{"CreateDirectoryW", 0x000323D2, NULL, NULL},
	{"CreateEventA", 0x000308AD, NULL, NULL},
	{"CreateEventW", 0x0000A6A9, NULL, NULL},
	{"CreateFiber", 0x0002FFAF, NULL, NULL},
	{"CreateFiberEx", 0x0002FFCF, NULL, NULL},
	{"CreateFileA", 0x00001A24, env_w32_hook_CreateFileA, NULL},
	{"CreateFileMappingA", 0x0000945C, NULL, NULL},
	{"CreateFileMappingW", 0x0000938E, NULL, NULL},
	{"CreateFileW", 0x00010760, NULL, NULL},
	{"CreateHardLinkA", 0x0006B629, NULL, NULL},
	{"CreateHardLinkW", 0x0006B46C, NULL, NULL},
	{"CreateIoCompletionPort", 0x00031385, NULL, NULL},
	{"CreateJobObjectA", 0x0006B38C, NULL, NULL},
	{"CreateJobObjectW", 0x0002CB03, NULL, NULL},
	{"CreateJobSet", 0x0006B35E, NULL, NULL},
	{"CreateMailslotA", 0x0002CC8B, NULL, NULL},
	{"CreateMailslotW", 0x0002CCDC, NULL, NULL},
	{"CreateMemoryResourceNotification", 0x0003965A, NULL, NULL},
	{"CreateMutexA", 0x0000E93F, NULL, NULL},
	{"CreateMutexW", 0x0000E8B7, NULL, NULL},
	{"CreateNamedPipeA", 0x0005FC74, NULL, NULL},
	{"CreateNamedPipeW", 0x0002F0D4, NULL, NULL},
	{"CreateNlsSecurityDescriptor", 0x0002AC6C, NULL, NULL},
	{"CreatePipe", 0x0001E0C7, NULL, NULL},
	{"CreateProcessA", 0x00002367, env_w32_hook_CreateProcessA, NULL},
	{"CreateProcessInternalA", 0x0001DDD6, NULL, NULL},
	{"CreateProcessInternalW", 0x00019513, NULL, NULL},
	{"CreateProcessInternalWSecure", 0x0007F1FC, NULL, NULL},
	{"CreateProcessW", 0x00002332, NULL, NULL},
	{"CreateRemoteThread", 0x0001042C, NULL, NULL},
	{"CreateSemaphoreA", 0x00012E1D, NULL, NULL},
	{"CreateSemaphoreW", 0x00010086, NULL, NULL},
	{"CreateSocketHandle", 0x0006B694, NULL, NULL},
	{"CreateTapePartition", 0x0006B14E, NULL, NULL},
	{"CreateThread", 0x00010637, NULL, NULL},
	{"CreateTimerQueue", 0x0002BFD6, NULL, NULL},
	{"CreateTimerQueueTimer", 0x0002117D, NULL, NULL},
	{"CreateToolhelp32Snapshot", 0x00064B47, NULL, NULL},
	{"CreateVirtualBuffer", 0x00034932, NULL, NULL},
	{"CreateWaitableTimerA", 0x00061A81, NULL, NULL},
	{"CreateWaitableTimerW", 0x0002FB52, NULL, NULL},
	{"DeactivateActCtx", 0x0000A675, NULL, NULL},
	{"DebugActiveProcess", 0x0005A123, NULL, NULL},
	{"DebugActiveProcessStop", 0x0005A5A9, NULL, NULL},
	{"DebugBreak", 0x00059B72, NULL, NULL},
	{"DebugBreakProcess", 0x0005A176, NULL, NULL},
	{"DebugSetProcessKillOnExit", 0x0005A19D, NULL, NULL},
	{"DecodePointer", 0x00008F88, NULL, NULL},
	{"DecodeSystemPointer", 0x00008F9F, NULL, NULL},
	{"DefineDosDeviceA", 0x0005C2C5, NULL, NULL},
	{"DefineDosDeviceW", 0x00021F1E, NULL, NULL},
	{"DelayLoadFailureHook", 0x0007DEAD, NULL, NULL},
	{"DeleteAtom", 0x00032695, NULL, NULL},
	{"DeleteCriticalSection", 0x00008FBC, NULL, NULL},
	{"DeleteFiber", 0x0002FE84, NULL, NULL},
	{"DeleteFileA", 0x00031EAB, env_w32_hook_DeleteFileA },
	{"DeleteFileW", 0x00031F31, NULL, NULL},
	{"DeleteTimerQueue", 0x00062DC3, NULL, NULL},
	{"DeleteTimerQueueEx", 0x00062D7C, NULL, NULL},
	{"DeleteTimerQueueTimer", 0x00021130, NULL, NULL},
	{"DeleteVolumeMountPointA", 0x0006A0DE, NULL, NULL},
	{"DeleteVolumeMountPointW", 0x00069930, NULL, NULL},
	{"DeviceIoControl", 0x00001625, NULL, NULL},
	{"DisableThreadLibraryCalls", 0x00011296, NULL, NULL},
	{"DisconnectNamedPipe", 0x0001269F, NULL, NULL},
	{"DnsHostnameToComputerNameA", 0x000585CF, NULL, NULL},
	{"DnsHostnameToComputerNameW", 0x0002CEB2, NULL, NULL},
	{"DosDateTimeToFileTime", 0x0003214E, NULL, NULL},
	{"DosPathToSessionPathA", 0x00061799, NULL, NULL},
	{"DosPathToSessionPathW", 0x0002C1E7, NULL, NULL},
	{"DuplicateConsoleHandle", 0x0001DD4D, NULL, NULL},
	{"DuplicateHandle", 0x0000DDFE, NULL, NULL},
	{"EncodePointer", 0x00008FDB, NULL, NULL},
	{"EncodeSystemPointer", 0x00008FF2, NULL, NULL},
	{"EndUpdateResourceA", 0x0006F949, NULL, NULL},
	{"EndUpdateResourceW", 0x0006F774, NULL, NULL},
	{"EnterCriticalSection", 0x0000900F, NULL, NULL},
	{"EnumCalendarInfoA", 0x00038211, NULL, NULL},
	{"EnumCalendarInfoExA", 0x00075749, NULL, NULL},
	{"EnumCalendarInfoExW", 0x0007877D, NULL, NULL},
	{"EnumCalendarInfoW", 0x0007875A, NULL, NULL},
	{"EnumDateFormatsA", 0x0007578A, NULL, NULL},
	{"EnumDateFormatsExA", 0x000757AA, NULL, NULL},
	{"EnumDateFormatsExW", 0x000787A0, NULL, NULL},
	{"EnumDateFormatsW", 0x000387E1, NULL, NULL},
	{"EnumLanguageGroupLocalesA", 0x000757E8, NULL, NULL},
	{"EnumLanguageGroupLocalesW", 0x00078703, NULL, NULL},
	{"EnumResourceLanguagesA", 0x0002E000, NULL, NULL},
	{"EnumResourceLanguagesW", 0x0005F631, NULL, NULL},
	{"EnumResourceNamesA", 0x0005F229, NULL, NULL},
	{"EnumResourceNamesW", 0x00055709, NULL, NULL},
	{"EnumResourceTypesA", 0x0005F03C, NULL, NULL},
	{"EnumResourceTypesW", 0x0005F449, NULL, NULL},
	{"EnumSystemCodePagesA", 0x00075827, NULL, NULL},
	{"EnumSystemCodePagesW", 0x0007873F, NULL, NULL},
	{"EnumSystemGeoID", 0x00078BD9, NULL, NULL},
	{"EnumSystemLanguageGroupsA", 0x000757CA, NULL, NULL},
	{"EnumSystemLanguageGroupsW", 0x000786E5, NULL, NULL},
	{"EnumSystemLocalesA", 0x00037CE1, NULL, NULL},
	{"EnumSystemLocalesW", 0x00078724, NULL, NULL},
	{"EnumTimeFormatsA", 0x0007576C, NULL, NULL},
	{"EnumTimeFormatsW", 0x000388BE, NULL, NULL},
	{"EnumUILanguagesA", 0x00075809, NULL, NULL},
	{"EnumUILanguagesW", 0x0002A8DC, NULL, NULL},
	{"EnumerateLocalComputerNamesA", 0x00058523, NULL, NULL},
	{"EnumerateLocalComputerNamesW", 0x000583A3, NULL, NULL},
	{"EraseTape", 0x0006B11B, NULL, NULL},
	{"EscapeCommFunction", 0x0006578E, NULL, NULL},
	{"ExitProcess", 0x0001CDDA, env_w32_hook_ExitProcess, NULL},
	{"ExitThread", 0x0000C058, env_w32_hook_ExitThread, NULL},
	{"ExitVDM", 0x00067695, NULL, NULL},
	{"ExpandEnvironmentStringsA", 0x000329D9, NULL, NULL},
	{"ExpandEnvironmentStringsW", 0x000305F6, NULL, NULL},
	{"ExpungeConsoleCommandHistoryA", 0x00070627, NULL, NULL},
	{"ExpungeConsoleCommandHistoryW", 0x0007060F, NULL, NULL},
	{"ExtendVirtualBuffer", 0x0005EBF4, NULL, NULL},
	{"FatalAppExitA", 0x00060CF8, NULL, NULL},
	{"FatalAppExitW", 0x00060CAA, NULL, NULL},
	{"FatalExit", 0x00060D46, NULL, NULL},
	{"FileTimeToDosDateTime", 0x0003065D, NULL, NULL},
	{"FileTimeToLocalFileTime", 0x0000E866, NULL, NULL},
	{"FileTimeToSystemTime", 0x0000E7EC, NULL, NULL},
	{"FillConsoleOutputAttribute", 0x00073044, NULL, NULL},
	{"FillConsoleOutputCharacterA", 0x00072FF9, NULL, NULL},
	{"FillConsoleOutputCharacterW", 0x00073020, NULL, NULL},
	{"FindActCtxSectionGuid", 0x00030F21, NULL, NULL},
	{"FindActCtxSectionStringA", 0x0006BB0F, NULL, NULL},
	{"FindActCtxSectionStringW", 0x0002FD4C, NULL, NULL},
	{"FindAtomA", 0x00030CFE, NULL, NULL},
	{"FindAtomW", 0x0002F827, NULL, NULL},
	{"FindClose", 0x0000EDD7, NULL, NULL},
	{"FindCloseChangeNotification", 0x000357D5, NULL, NULL},
	{"FindFirstChangeNotificationA", 0x0005C4AB, NULL, NULL},
	{"FindFirstChangeNotificationW", 0x00034BEF, NULL, NULL},
	{"FindFirstFileA", 0x000137D9, NULL, NULL},
	{"FindFirstFileExA", 0x0005C512, NULL, NULL},
	{"FindFirstFileExW", 0x0000EA7D, NULL, NULL},
	{"FindFirstFileW", 0x0000EEE1, NULL, NULL},
	{"FindFirstVolumeA", 0x0006A259, NULL, NULL},
	{"FindFirstVolumeMountPointA", 0x00069D19, NULL, NULL},
	{"FindFirstVolumeMountPointW", 0x00068DB1, NULL, NULL},
	{"FindFirstVolumeW", 0x0002D2AF, NULL, NULL},
	{"FindNextChangeNotification", 0x00032113, NULL, NULL},
	{"FindNextFileA", 0x00034EB1, NULL, NULL},
	{"FindNextFileW", 0x0000EF3A, NULL, NULL},
	{"FindNextVolumeA", 0x00069BFF, NULL, NULL},
	{"FindNextVolumeMountPointA", 0x00069E49, NULL, NULL},
	{"FindNextVolumeMountPointW", 0x0006905D, NULL, NULL},
	{"FindNextVolumeW", 0x0002CF9B, NULL, NULL},
	{"FindResourceA", 0x0000BE89, NULL, NULL},
	{"FindResourceExA", 0x00035F78, NULL, NULL},
	{"FindResourceExW", 0x0000AC88, NULL, NULL},
	{"FindResourceW", 0x0000BBCE, NULL, NULL},
	{"FindVolumeClose", 0x0002CF60, NULL, NULL},
	{"FindVolumeMountPointClose", 0x000357D5, NULL, NULL},
	{"FlushConsoleInputBuffer", 0x00073B1C, NULL, NULL},
	{"FlushFileBuffers", 0x00012641, NULL, NULL},
	{"FlushInstructionCache", 0x000355BC, NULL, NULL},
	{"FlushViewOfFile", 0x00035971, NULL, NULL},
	{"FoldStringA", 0x00075EB1, NULL, NULL},
	{"FoldStringW", 0x00079636, NULL, NULL},
	{"FormatMessageA", 0x0002F7A0, NULL, NULL},
	{"FormatMessageW", 0x00034B8F, NULL, NULL},
	{"FreeConsole", 0x0007108D, NULL, NULL},
	{"FreeEnvironmentStringsA", 0x0001DF77, NULL, NULL},
	{"FreeEnvironmentStringsW", 0x00014AE7, NULL, NULL},
	{"FreeLibrary", 0x0000ABDE, NULL, NULL},
	{"FreeLibraryAndExitThread", 0x0000C170, NULL, NULL},
	{"FreeResource", 0x000260C2, NULL, NULL},
	{"FreeUserPhysicalPages", 0x0005E740, NULL, NULL},
	{"FreeVirtualBuffer", 0x00034B69, NULL, NULL},
	{"GenerateConsoleCtrlEvent", 0x00073A21, NULL, NULL},
	{"GetACP", 0x00009915, NULL, NULL},
	{"GetAtomNameA", 0x0005B2AB, NULL, NULL},
	{"GetAtomNameW", 0x000330E7, NULL, NULL},
	{"GetBinaryType", 0x0006802B, NULL, NULL},
	{"GetBinaryTypeA", 0x0006802B, NULL, NULL},
	{"GetBinaryTypeW", 0x00067BCC, NULL, NULL},
	{"GetCPFileNameFromRegistry", 0x000384DB, NULL, NULL},
	{"GetCPInfo", 0x00012E76, NULL, NULL},
	{"GetCPInfoExA", 0x00076047, NULL, NULL},
	{"GetCPInfoExW", 0x0007A1CD, NULL, NULL},
	{"GetCalendarInfoA", 0x0007596B, NULL, NULL},
	{"GetCalendarInfoW", 0x00039020, NULL, NULL},
	{"GetComPlusPackageInstallStatus", 0x0006BBA2, NULL, NULL},
	{"GetCommConfig", 0x00066D09, NULL, NULL},
	{"GetCommMask", 0x0006588A, NULL, NULL},
	{"GetCommModemStatus", 0x00065913, NULL, NULL},
	{"GetCommProperties", 0x0006599C, NULL, NULL},
	{"GetCommState", 0x00065A54, NULL, NULL},
	{"GetCommTimeouts", 0x00022128, NULL, NULL},
	{"GetCommandLineA", 0x00012F1D, NULL, NULL},
	{"GetCommandLineW", 0x00016F83, NULL, NULL},
	{"GetCompressedFileSizeA", 0x0005D499, NULL, NULL},
	{"GetCompressedFileSizeW", 0x0005D371, NULL, NULL},
	{"GetComputerNameA", 0x000216A4, NULL, NULL},
	{"GetComputerNameExA", 0x000582A7, NULL, NULL},
	{"GetComputerNameExW", 0x000201F1, NULL, NULL},
	{"GetComputerNameW", 0x000316C7, NULL, NULL},
	{"GetConsoleAliasA", 0x000700B2, NULL, NULL},
	{"GetConsoleAliasExesA", 0x0007054C, NULL, NULL},
	{"GetConsoleAliasExesLengthA", 0x00070252, NULL, NULL},
	{"GetConsoleAliasExesLengthW", 0x00070245, NULL, NULL},
	{"GetConsoleAliasExesW", 0x00070531, NULL, NULL},
	{"GetConsoleAliasW", 0x00070086, NULL, NULL},
	{"GetConsoleAliasesA", 0x000703E7, NULL, NULL},
	{"GetConsoleAliasesLengthA", 0x000701B9, NULL, NULL},
	{"GetConsoleAliasesLengthW", 0x000701A1, NULL, NULL},
	{"GetConsoleAliasesW", 0x000703C9, NULL, NULL},
	{"GetConsoleCP", 0x000740D3, NULL, NULL},
	{"GetConsoleCharType", 0x000751A3, NULL, NULL},
	{"GetConsoleCommandHistoryA", 0x000709A7, NULL, NULL},
	{"GetConsoleCommandHistoryLengthA", 0x00070805, NULL, NULL},
	{"GetConsoleCommandHistoryLengthW", 0x000707ED, NULL, NULL},
	{"GetConsoleCommandHistoryW", 0x00070989, NULL, NULL},
	{"GetConsoleCursorInfo", 0x00073561, NULL, NULL},
	{"GetConsoleCursorMode", 0x000747FF, NULL, NULL},
	{"GetConsoleDisplayMode", 0x00037C53, NULL, NULL},
	{"GetConsoleFontInfo", 0x00073799, NULL, NULL},
	{"GetConsoleFontSize", 0x000738C1, NULL, NULL},
	{"GetConsoleHardwareState", 0x00071C19, NULL, NULL},
	{"GetConsoleInputExeNameA", 0x00070CFC, NULL, NULL},
	{"GetConsoleInputExeNameW", 0x00070AD1, NULL, NULL},
	{"GetConsoleInputWaitHandle", 0x000715F9, NULL, NULL},
	{"GetConsoleKeyboardLayoutNameA", 0x00074329, NULL, NULL},
	{"GetConsoleKeyboardLayoutNameW", 0x00074341, NULL, NULL},
	{"GetConsoleMode", 0x0001AF14, NULL, NULL},
	{"GetConsoleNlsMode", 0x00074F87, NULL, NULL},
	{"GetConsoleOutputCP", 0x0001B18F, NULL, NULL},
	{"GetConsoleProcessList", 0x000743C5, NULL, NULL},
	{"GetConsoleScreenBufferInfo", 0x0001BC2B, NULL, NULL},
	{"GetConsoleSelectionInfo", 0x00073629, NULL, NULL},
	{"GetConsoleTitleA", 0x00070A39, NULL, NULL},
	{"GetConsoleTitleW", 0x0001BA3C, NULL, NULL},
	{"GetConsoleWindow", 0x00074359, NULL, NULL},
	{"GetCurrencyFormatA", 0x00075B79, NULL, NULL},
	{"GetCurrencyFormatW", 0x0007B6CA, NULL, NULL},
	{"GetCurrentActCtx", 0x000300A9, NULL, NULL},
	{"GetCurrentConsoleFont", 0x0007394F, NULL, NULL},
	{"GetCurrentDirectoryA", 0x00034FFE, NULL, NULL},
	{"GetCurrentDirectoryW", 0x0000B877, NULL, NULL},
	{"GetCurrentProcess", 0x0000DDF5, NULL, NULL},
	{"GetCurrentProcessId", 0x00009920, NULL, NULL},
	{"GetCurrentThread", 0x000098EB, NULL, NULL},
	{"GetCurrentThreadId", 0x00009728, NULL, NULL},
	{"GetDateFormatA", 0x000361EE, NULL, NULL},
	{"GetDateFormatW", 0x00033775, NULL, NULL},
	{"GetDefaultCommConfigA", 0x00066A41, NULL, NULL},
	{"GetDefaultCommConfigW", 0x00066949, NULL, NULL},
	{"GetDefaultSortkeySize", 0x0007AA41, NULL, NULL},
	{"GetDevicePowerState", 0x00060B1C, NULL, NULL},
	{"GetDiskFreeSpaceA", 0x000302ED, NULL, NULL},
	{"GetDiskFreeSpaceExA", 0x0003039B, NULL, NULL},
	{"GetDiskFreeSpaceExW", 0x00012803, NULL, NULL},
	{"GetDiskFreeSpaceW", 0x000301AF, NULL, NULL},
	{"GetDllDirectoryA", 0x0005EF47, NULL, NULL},
	{"GetDllDirectoryW", 0x0005EDD7, NULL, NULL},
	{"GetDriveTypeA", 0x000214E3, NULL, NULL},
	{"GetDriveTypeW", 0x0000B2D0, NULL, NULL},
	{"GetEnvironmentStrings", 0x0001CF5B, NULL, NULL},
	{"GetEnvironmentStringsA", 0x0001CF5B, NULL, NULL},
	{"GetEnvironmentStringsW", 0x00012F08, NULL, NULL},
	{"GetEnvironmentVariableA", 0x00014AF2, NULL, NULL},
	{"GetEnvironmentVariableW", 0x0000F0F4, NULL, NULL},
	{"GetExitCodeProcess", 0x0001AE17, NULL, NULL},
	{"GetExitCodeThread", 0x00021435, NULL, NULL},
	{"GetExpandedNameA", 0x00064BCF, NULL, NULL},
	{"GetExpandedNameW", 0x00064C7C, NULL, NULL},
	{"GetFileAttributesA", 0x0001153C, NULL, NULL},
	{"GetFileAttributesExA", 0x000137B1, NULL, NULL},
	{"GetFileAttributesExW", 0x000110F5, NULL, NULL},
	{"GetFileAttributesW", 0x0000B74C, NULL, NULL},
	{"GetFileInformationByHandle", 0x00010C6D, NULL, NULL},
	{"GetFileSize", 0x00010A77, NULL, NULL},
	{"GetFileSizeEx", 0x00010A09, NULL, NULL},
	{"GetFileTime", 0x00031C45, NULL, NULL},
	{"GetFileType", 0x00010E51, NULL, NULL},
	{"GetFirmwareEnvironmentVariableA", 0x0005E534, NULL, NULL},
	{"GetFirmwareEnvironmentVariableW", 0x0005E41D, NULL, NULL},
	{"GetFullPathNameA", 0x000138FC, NULL, NULL},
	{"GetFullPathNameW", 0x0000B852, NULL, NULL},
	{"GetGeoInfoA", 0x00075842, NULL, NULL},
	{"GetGeoInfoW", 0x00078847, NULL, NULL},
	{"GetHandleContext", 0x0006B683, NULL, NULL},
	{"GetHandleInformation", 0x0002BDB5, NULL, NULL},
	{"GetLargestConsoleWindowSize", 0x00074631, NULL, NULL},
	{"GetLastError", 0x0000902D, NULL, NULL},
	{"GetLinguistLangSize", 0x0007AA6B, NULL, NULL},
	{"GetLocalTime", 0x0000A7D4, NULL, NULL},
	{"GetLocaleInfoA", 0x0000D262, NULL, NULL},
	{"GetLocaleInfoW", 0x00011562, NULL, NULL},
	{"GetLogicalDriveStringsA", 0x0002C2D3, NULL, NULL},
	{"GetLogicalDriveStringsW", 0x000603CF, NULL, NULL},
	{"GetLogicalDrives", 0x00030B14, NULL, NULL},
	{"GetLongPathNameA", 0x00068586, NULL, NULL},
	{"GetLongPathNameW", 0x00013353, NULL, NULL},
	{"GetMailslotInfo", 0x0005EB58, NULL, NULL},
	{"GetModuleFileNameA", 0x0000B4CF, NULL, NULL},
	{"GetModuleFileNameW", 0x0000B3D5, NULL, NULL},
	{"GetModuleHandleA", 0x0000B6A1, NULL, NULL},
	{"GetModuleHandleExA", 0x0005EFE6, NULL, NULL},
	{"GetModuleHandleExW", 0x0001FCC1, NULL, NULL},
	{"GetModuleHandleW", 0x0000E43D, NULL, NULL},
	{"GetNamedPipeHandleStateA", 0x0005FCEB, NULL, NULL},
	{"GetNamedPipeHandleStateW", 0x0005FA85, NULL, NULL},
	{"GetNamedPipeInfo", 0x0005F88A, NULL, NULL},
	{"GetNativeSystemInfo", 0x00037945, NULL, NULL},
	{"GetNextVDMCommand", 0x00066F43, NULL, NULL},
	{"GetNlsSectionName", 0x00017F7D, NULL, NULL},
	{"GetNumaAvailableMemory", 0x0005FFC4, NULL, NULL},
	{"GetNumaAvailableMemoryNode", 0x0006000A, NULL, NULL},
	{"GetNumaHighestNodeNumber", 0x0005FE41, NULL, NULL},
	{"GetNumaNodeProcessorMask", 0x0005FF19, NULL, NULL},
	{"GetNumaProcessorMap", 0x0005FF7E, NULL, NULL},
	{"GetNumaProcessorNode", 0x0005FE8C, NULL, NULL},
	{"GetNumberFormatA", 0x0002EC56, NULL, NULL},
	{"GetNumberFormatW", 0x000344BC, NULL, NULL},
	{"GetNumberOfConsoleFonts", 0x00074501, NULL, NULL},
	{"GetNumberOfConsoleInputEvents", 0x0007456D, NULL, NULL},
	{"GetNumberOfConsoleMouseButtons", 0x000736E1, NULL, NULL},
	{"GetOEMCP", 0x000127A7, NULL, NULL},
	{"GetOverlappedResult", 0x000315C4, NULL, NULL},
	{"GetPriorityClass", 0x00060E13, NULL, NULL},
	{"GetPrivateProfileIntA", 0x00036434, NULL, NULL},
	{"GetPrivateProfileIntW", 0x00032730, NULL, NULL},
	{"GetPrivateProfileSectionA", 0x00035F21, NULL, NULL},
	{"GetPrivateProfileSectionNamesA", 0x00032DA7, NULL, NULL},
	{"GetPrivateProfileSectionNamesW", 0x0005BB0A, NULL, NULL},
	{"GetPrivateProfileSectionW", 0x0001EDBD, NULL, NULL},
	{"GetPrivateProfileStringA", 0x00032B56, NULL, NULL},
	{"GetPrivateProfileStringW", 0x0000F95D, NULL, NULL},
	{"GetPrivateProfileStructA", 0x0005BB2B, NULL, NULL},
	{"GetPrivateProfileStructW", 0x0005BC95, NULL, NULL},
	{"GetProcAddress", 0x0000ADA0, env_w32_hook_GetProcAddress, NULL},
	{"GetProcessAffinityMask", 0x00021765, NULL, NULL},
	{"GetProcessHandleCount", 0x00061186, NULL, NULL},
	{"GetProcessHeap", 0x0000ABC1, NULL, NULL},
	{"GetProcessHeaps", 0x0005E9DB, NULL, NULL},
	{"GetProcessId", 0x00060C75, NULL, NULL},
	{"GetProcessIoCounters", 0x00061155, NULL, NULL},
	{"GetProcessPriorityBoost", 0x0006111B, NULL, NULL},
	{"GetProcessShutdownParameters", 0x00060E79, NULL, NULL},
	{"GetProcessTimes", 0x000352D9, NULL, NULL},
	{"GetProcessVersion", 0x00012C23, NULL, NULL},
	{"GetProcessWorkingSetSize", 0x00061068, NULL, NULL},
	{"GetProfileIntA", 0x000364A9, NULL, NULL},
	{"GetProfileIntW", 0x0002F89A, NULL, NULL},
	{"GetProfileSectionA", 0x0005C0D7, NULL, NULL},
	{"GetProfileSectionW", 0x0005C110, NULL, NULL},
	{"GetProfileStringA", 0x00021495, NULL, NULL},
	{"GetProfileStringW", 0x000213F8, NULL, NULL},
	{"GetQueuedCompletionStatus", 0x0000A71D, NULL, NULL},
	{"GetShortPathNameA", 0x00035BB0, NULL, NULL},
	{"GetShortPathNameW", 0x0001F26E, NULL, NULL},
	{"GetStartupInfoA", 0x00001EEE, NULL, NULL},
	{"GetStartupInfoW", 0x00001E50, NULL, NULL},
	{"GetStdHandle", 0x00012F39, NULL, NULL},
	{"GetStringTypeA", 0x00038A0C, NULL, NULL},
	{"GetStringTypeExA", 0x000760CF, NULL, NULL},
	{"GetStringTypeExW", 0x0000BFEF, NULL, NULL},
	{"GetStringTypeW", 0x0000A490, NULL, NULL},
	{"GetSystemDefaultLCID", 0x0000BF3D, NULL, NULL},
	{"GetSystemDefaultLangID", 0x000127B2, NULL, NULL},
	{"GetSystemDefaultUILanguage", 0x00013038, NULL, NULL},
	{"GetSystemDirectoryA", 0x00014EEA, env_w32_hook_GetSystemDirectoryA },
	{"GetSystemDirectoryW", 0x00031DB9, NULL, NULL},
	{"GetSystemInfo", 0x00012D56, NULL, NULL},
	{"GetSystemPowerStatus", 0x00035340, NULL, NULL},
	{"GetSystemRegistryQuota", 0x000611C0, NULL, NULL},
	{"GetSystemTime", 0x0000176B, NULL, NULL},
	{"GetSystemTimeAdjustment", 0x0002D36F, NULL, NULL},
	{"GetSystemTimeAsFileTime", 0x000017E5, NULL, NULL},
	{"GetSystemTimes", 0x00060F22, NULL, NULL},
	{"GetSystemWindowsDirectoryA", 0x000212F1, NULL, NULL},
	{"GetSystemWindowsDirectoryW", 0x0000AD29, NULL, NULL},
	{"GetSystemWow64DirectoryA", 0x0002146C, NULL, NULL},
	{"GetSystemWow64DirectoryW", 0x0002146C, NULL, NULL},
	{"GetTapeParameters", 0x0006B1C2, NULL, NULL},
	{"GetTapePosition", 0x0006B08C, NULL, NULL},
	{"GetTapeStatus", 0x0006B25F, NULL, NULL},
	{"GetTempFileNameA", 0x000608FF, NULL, NULL},
	{"GetTempFileNameW", 0x000359B7, NULL, NULL},
	{"GetTempPathA", 0x00035DCA, NULL, NULL},
	{"GetTempPathW", 0x00030789, NULL, NULL},
	{"GetThreadContext", 0x0003970D, NULL, NULL},
	{"GetThreadIOPendingFlag", 0x00062D09, NULL, NULL},
	{"GetThreadLocale", 0x0000A415, NULL, NULL},
	{"GetThreadPriority", 0x0000A793, NULL, NULL},
	{"GetThreadPriorityBoost", 0x00062A6B, NULL, NULL},
	{"GetThreadSelectorEntry", 0x0005A1E8, NULL, NULL},
	{"GetThreadTimes", 0x00062C9C, NULL, NULL},
	{"GetTickCount", 0x0000929C, env_w32_hook_GetTickCount, NULL},
	{"GetTimeFormatA", 0x0003632D, NULL, NULL},
	{"GetTimeFormatW", 0x00033FD3, NULL, NULL},
	{"GetTimeZoneInformation", 0x000350BF, NULL, NULL},
	{"GetUserDefaultLCID", 0x00009F10, NULL, NULL},
	{"GetUserDefaultLangID", 0x0000BF64, NULL, NULL},
	{"GetUserDefaultUILanguage", 0x00013070, NULL, NULL},
	{"GetUserGeoID", 0x0003798E, NULL, NULL},
	{"GetVDMCurrentDirectories", 0x00067849, NULL, NULL},
	{"GetVersion", 0x000111DA, NULL, NULL},
	{"GetVersionExA", 0x00012ADE, NULL, NULL},
	{"GetVersionExW", 0x0000AE65, NULL, NULL},
	{"GetVolumeInformationA", 0x00021BA5, NULL, NULL},
	{"GetVolumeInformationW", 0x0000F9E5, NULL, NULL},
	{"GetVolumeNameForVolumeMountPointA", 0x00069F61, NULL, NULL},
	{"GetVolumeNameForVolumeMountPointW", 0x0001FB88, NULL, NULL},
	{"GetVolumePathNameA", 0x0002E8B2, NULL, NULL},
	{"GetVolumePathNameW", 0x0002E61C, NULL, NULL},
	{"GetVolumePathNamesForVolumeNameA", 0x0006A100, NULL, NULL},
	{"GetVolumePathNamesForVolumeNameW", 0x00020D14, NULL, NULL},
	{"GetWindowsDirectoryA", 0x00021363, NULL, NULL},
	{"GetWindowsDirectoryW", 0x0000AD7B, NULL, NULL},
	{"GetWriteWatch", 0x0005E7CA, NULL, NULL},
	{"GlobalAddAtomA", 0x000360A9, NULL, NULL},
	{"GlobalAddAtomW", 0x0001006C, NULL, NULL},
	{"GlobalAlloc", 0x0000FD2D, NULL, NULL},
	{"GlobalCompact", 0x0005E670, NULL, NULL},
	{"GlobalDeleteAtom", 0x00030BBB, NULL, NULL},
	{"GlobalFindAtomA", 0x000360C3, NULL, NULL},
	{"GlobalFindAtomW", 0x00034E97, NULL, NULL},
	{"GlobalFix", 0x0005E686, NULL, NULL},
	{"GlobalFlags", 0x00036772, NULL, NULL},
	{"GlobalFree", 0x0000FC2F, NULL, NULL},
	{"GlobalGetAtomNameA", 0x0005B28B, NULL, NULL},
	{"GlobalGetAtomNameW", 0x0002C3BE, NULL, NULL},
	{"GlobalHandle", 0x00034CB9, NULL, NULL},
	{"GlobalLock", 0x0000FF19, NULL, NULL},
	{"GlobalMemoryStatus", 0x000310F2, NULL, NULL},
	{"GlobalMemoryStatusEx", 0x0001F992, NULL, NULL},
	{"GlobalReAlloc", 0x000123B9, NULL, NULL},
	{"GlobalSize", 0x00034DA1, NULL, NULL},
	{"GlobalUnWire", 0x0005E6CA, NULL, NULL},
	{"GlobalUnfix", 0x0005E6A0, NULL, NULL},
	{"GlobalUnlock", 0x0000FE82, NULL, NULL},
	{"GlobalWire", 0x0005E6BA, NULL, NULL},
	{"Heap32First", 0x00063ADE, NULL, NULL},
	{"Heap32ListFirst", 0x00063999, NULL, NULL},
	{"Heap32ListNext", 0x00063A47, NULL, NULL},
	{"Heap32Next", 0x00063BF8, NULL, NULL},
	{"HeapAlloc", 0x00009048, NULL, NULL},
	{"HeapCompact", 0x0003611E, NULL, NULL},
	{"HeapCreate", 0x00012BB6, NULL, NULL},
	{"HeapCreateTagsW", 0x0005E8C9, NULL, NULL},
	{"HeapDestroy", 0x00010EF8, NULL, NULL},
	{"HeapExtend", 0x0005E898, NULL, NULL},
	{"HeapFree", 0x0000905E, NULL, NULL},
	{"HeapLock", 0x0005E9EC, NULL, NULL},
	{"HeapQueryInformation", 0x0005EB25, NULL, NULL},
	{"HeapQueryTagW", 0x0005E8DA, NULL, NULL},
	{"HeapReAlloc", 0x00009070, NULL, NULL},
	{"HeapSetInformation", 0x00039469, NULL, NULL},
	{"HeapSize", 0x00009088, NULL, NULL},
	{"HeapSummary", 0x0005E8EB, NULL, NULL},
	{"HeapUnlock", 0x0005EA06, NULL, NULL},
	{"HeapUsage", 0x0005E947, NULL, NULL},
	{"HeapValidate", 0x0005E9BB, NULL, NULL},
	{"HeapWalk", 0x0005EA20, NULL, NULL},
	{"InitAtomTable", 0x0002AF8F, NULL, NULL},
	{"InitializeCriticalSection", 0x00009EF1, NULL, NULL},
	{"InitializeCriticalSectionAndSpinCount", 0x0000B829, NULL, NULL},
	{"InitializeSListHead", 0x0000909A, NULL, NULL},
	{"InterlockedCompareExchange", 0x000097A2, NULL, NULL},
	{"InterlockedDecrement", 0x0000977A, NULL, NULL},
	{"InterlockedExchange", 0x0000978E, NULL, NULL},
	{"InterlockedExchangeAdd", 0x000097B6, NULL, NULL},
	{"InterlockedFlushSList", 0x000090B7, NULL, NULL},
	{"InterlockedIncrement", 0x00009766, NULL, NULL},
	{"InterlockedPopEntrySList", 0x000090D6, NULL, NULL},
	{"InterlockedPushEntrySList", 0x000090F8, NULL, NULL},
	{"InvalidateConsoleDIBits", 0x00073215, NULL, NULL},
	{"IsBadCodePtr", 0x0000BCCF, NULL, NULL},
	{"IsBadHugeReadPtr", 0x0003593F, NULL, NULL},
	{"IsBadHugeWritePtr", 0x0000BF9D, NULL, NULL},
	{"IsBadReadPtr", 0x00009E01, NULL, NULL},
	{"IsBadStringPtrA", 0x00032259, NULL, NULL},
	{"IsBadStringPtrW", 0x0000A5DC, NULL, NULL},
	{"IsBadWritePtr", 0x00009E79, NULL, NULL},
	{"IsDBCSLeadByte", 0x0000B7DC, NULL, NULL},
	{"IsDBCSLeadByteEx", 0x0007A4CE, NULL, NULL},
	{"IsDebuggerPresent", 0x00013093, NULL, NULL},
	{"IsProcessInJob", 0x0006B324, NULL, NULL},
	{"IsProcessorFeaturePresent", 0x0000AE2A, NULL, NULL},
	{"IsSystemResumeAutomatic", 0x00060B60, NULL, NULL},
	{"IsValidCodePage", 0x000110CB, NULL, NULL},
	{"IsValidLanguageGroup", 0x000763EF, NULL, NULL},
	{"IsValidLocale", 0x0001C48B, NULL, NULL},
	{"IsValidUILanguage", 0x000764FB, NULL, NULL},
	{"IsWow64Process", 0x00015199, NULL, NULL},
	{"LCMapStringA", 0x00038DE8, NULL, NULL},
	{"LCMapStringW", 0x0000CCA8, NULL, NULL},
	{"LZClose", 0x000654BB, NULL, NULL},
	{"LZCloseFile", 0x00065444, NULL, NULL},
	{"LZCopy", 0x000592F8, NULL, NULL},
	{"LZCreateFileW", 0x00064F85, NULL, NULL},
	{"LZDone", 0x0007F1FC, NULL, NULL},
	{"LZInit", 0x00064E2A, NULL, NULL},
	{"LZOpenFileA", 0x00065053, NULL, NULL},
	{"LZOpenFileW", 0x00065114, NULL, NULL},
	{"LZRead", 0x00065236, NULL, NULL},
	{"LZSeek", 0x000651AB, NULL, NULL},
	{"LZStart", 0x0007E9E7, NULL, NULL},
	{"LeaveCriticalSection", 0x0000911B, NULL, NULL},
	{"LoadLibraryA", 0x00001D77, env_w32_hook_LoadLibrayA, NULL},
	{"LoadLibraryExA", 0x00001D4F, NULL, NULL},
	{"LoadLibraryExW", 0x00001AF1, NULL, NULL},
	{"LoadLibraryW", 0x0000AE4B, NULL, NULL},
	{"LoadModule", 0x0006147E, NULL, NULL},
	{"LoadResource", 0x00009FB5, NULL, NULL},
	{"LocalAlloc", 0x0000998D, NULL, NULL},
	{"LocalCompact", 0x0005E670, NULL, NULL},
	{"LocalFileTimeToFileTime", 0x00035524, NULL, NULL},
	{"LocalFlags", 0x00055A0E, NULL, NULL},
	{"LocalFree", 0x0000992F, NULL, NULL},
	{"LocalHandle", 0x00055B09, NULL, NULL},
	{"LocalLock", 0x00032E1D, NULL, NULL},
	{"LocalReAlloc", 0x00030927, NULL, NULL},
	{"LocalShrink", 0x0005E882, NULL, NULL},
	{"LocalSize", 0x000325BC, NULL, NULL},
	{"LocalUnlock", 0x00032EB1, NULL, NULL},
	{"LockFile", 0x00032361, NULL, NULL},
	{"LockFileEx", 0x0002F569, NULL, NULL},
	{"LockResource", 0x0000CC97, NULL, NULL},
	{"MapUserPhysicalPages", 0x0005E76E, NULL, NULL},
	{"MapUserPhysicalPagesScatter", 0x0005E79C, NULL, NULL},
	{"MapViewOfFile", 0x0000B905, NULL, NULL},
	{"MapViewOfFileEx", 0x0000B896, NULL, NULL},
	{"Module32First", 0x00064268, NULL, NULL},
	{"Module32FirstW", 0x000641AF, NULL, NULL},
	{"Module32Next", 0x000643ED, NULL, NULL},
	{"Module32NextW", 0x0006434C, NULL, NULL},
	{"MoveFileA", 0x00035E8F, NULL, NULL},
	{"MoveFileExA", 0x0005D4C3, NULL, NULL},
	{"MoveFileExW", 0x0003565B, NULL, NULL},
	{"MoveFileW", 0x00021261, NULL, NULL},
	{"MoveFileWithProgressA", 0x00035EAE, NULL, NULL},
	{"MoveFileWithProgressW", 0x0001F72E, NULL, NULL},
	{"MulDiv", 0x000097C6, NULL, NULL},
	{"MultiByteToWideChar", 0x00009BF8, NULL, NULL},
	{"NlsConvertIntegerToString", 0x00014F5C, NULL, NULL},
	{"NlsGetCacheUpdateCount", 0x00035819, NULL, NULL},
	{"NlsResetProcessLocale", 0x000763C9, NULL, NULL},
	{"NumaVirtualQueryNode", 0x000600D2, NULL, NULL},
	{"OpenConsoleW", 0x00010FE1, NULL, NULL},
	{"OpenDataFile", 0x0002AD98, NULL, NULL},
	{"OpenEventA", 0x0001320C, NULL, NULL},
	{"OpenEventW", 0x00013140, NULL, NULL},
	{"OpenFile", 0x00021982, NULL, NULL},
	{"OpenFileMappingA", 0x0000BB76, NULL, NULL},
	{"OpenFileMappingW", 0x0000BADA, NULL, NULL},
	{"OpenJobObjectA", 0x0006B3F8, NULL, NULL},
	{"OpenJobObjectW", 0x0006B280, NULL, NULL},
	{"OpenMutexA", 0x0000EA1B, NULL, NULL},
	{"OpenMutexW", 0x0000E995, NULL, NULL},
	{"OpenProcess", 0x000309E1, NULL, NULL},
	{"OpenProfileUserMapping", 0x0003331F, NULL, NULL},
	{"OpenSemaphoreA", 0x0002CA47, NULL, NULL},
	{"OpenSemaphoreW", 0x0002E30F, NULL, NULL},
	{"OpenThread", 0x0002FC00, NULL, NULL},
	{"OpenWaitableTimerA", 0x00061AF0, NULL, NULL},
	{"OpenWaitableTimerW", 0x00061985, NULL, NULL},
	{"OutputDebugStringA", 0x00059D78, NULL, NULL},
	{"OutputDebugStringW", 0x0005A42D, NULL, NULL},
	{"PeekConsoleInputA", 0x0007348D, NULL, NULL},
	{"PeekConsoleInputW", 0x000734B0, NULL, NULL},
	{"PeekNamedPipe", 0x0005F90F, NULL, NULL},
	{"PostQueuedCompletionStatus", 0x000126F2, NULL, NULL},
	{"PrepareTape", 0x0006B0E8, NULL, NULL},
	{"PrivCopyFileExW", 0x0002005F, NULL, NULL},
	{"PrivMoveFileIdentityW", 0x0005D0E9, NULL, NULL},
	{"Process32First", 0x00063E1D, NULL, NULL},
	{"Process32FirstW", 0x00063D64, NULL, NULL},
	{"Process32Next", 0x00063F90, NULL, NULL},
	{"Process32NextW", 0x00063EEF, NULL, NULL},
	{"ProcessIdToSessionId", 0x00012F89, NULL, NULL},
	{"PulseEvent", 0x0002C05E, NULL, NULL},
	{"PurgeComm", 0x00065D02, NULL, NULL},
	{"QueryActCtxW", 0x000162DB, NULL, NULL},
	{"QueryDepthSList", 0x00009139, NULL, NULL},
	{"QueryDosDeviceA", 0x0005C36C, NULL, NULL},
	{"QueryDosDeviceW", 0x00021D8D, NULL, NULL},
	{"QueryInformationJobObject", 0x0002AFC9, NULL, NULL},
	{"QueryMemoryResourceNotification", 0x000395D8, NULL, NULL},
	{"QueryPerformanceCounter", 0x0000A427, NULL, NULL},
	{"QueryPerformanceFrequency", 0x0002FA46, NULL, NULL},
	{"QueryWin31IniFilesMappedToRegistry", 0x0005B71C, NULL, NULL},
	{"QueueUserAPC", 0x0002C082, NULL, NULL},
	{"QueueUserWorkItem", 0x00030A62, NULL, NULL},
	{"RaiseException", 0x00012A09, NULL, NULL},
	{"ReadConsoleA", 0x00071A1D, NULL, NULL},
	{"ReadConsoleInputA", 0x000734D3, NULL, NULL},
	{"ReadConsoleInputExA", 0x00073519, NULL, NULL},
	{"ReadConsoleInputExW", 0x0007353D, NULL, NULL},
	{"ReadConsoleInputW", 0x000734F6, NULL, NULL},
	{"ReadConsoleOutputA", 0x00072805, NULL, NULL},
	{"ReadConsoleOutputAttribute", 0x00072D25, NULL, NULL},
	{"ReadConsoleOutputCharacterA", 0x00072CD9, NULL, NULL},
	{"ReadConsoleOutputCharacterW", 0x00072CFF, NULL, NULL},
	{"ReadConsoleOutputW", 0x000727E1, NULL, NULL},
	{"ReadConsoleW", 0x00071A6C, NULL, NULL},
	{"ReadDirectoryChangesW", 0x0003162F, NULL, NULL},
	{"ReadFile", 0x0000180E, NULL, NULL},
	{"ReadFileEx", 0x0002BCFB, NULL, NULL},
	{"ReadFileScatter", 0x0002DE51, NULL, NULL},
	{"ReadProcessMemory", 0x000021CC, NULL, NULL},
	{"RegisterConsoleIME", 0x00074AB9, NULL, NULL},
	{"RegisterConsoleOS2", 0x000748C9, NULL, NULL},
	{"RegisterConsoleVDM", 0x00071AC2, NULL, NULL},
	{"RegisterWaitForInputIdle", 0x00016F8E, NULL, NULL},
	{"RegisterWaitForSingleObject", 0x000211CD, NULL, NULL},
	{"RegisterWaitForSingleObjectEx", 0x0002B086, NULL, NULL},
	{"RegisterWowBaseHandlers", 0x0005E65A, NULL, NULL},
	{"RegisterWowExec", 0x000679A9, NULL, NULL},
	{"ReleaseActCtx", 0x0001305F, NULL, NULL},
	{"ReleaseMutex", 0x000024A7, NULL, NULL},
	{"ReleaseSemaphore", 0x0000BFAD, NULL, NULL},
	{"RemoveDirectoryA", 0x0005B219, NULL, NULL},
	{"RemoveDirectoryW", 0x00036F5B, NULL, NULL},
	{"RemoveLocalAlternateComputerNameA", 0x00059050, NULL, NULL},
	{"RemoveLocalAlternateComputerNameW", 0x00058F6F, NULL, NULL},
	{"RemoveVectoredExceptionHandler", 0x00009152, NULL, NULL},
	{"ReplaceFile", 0x00036C3C, NULL, NULL},
	{"ReplaceFileA", 0x0005E307, NULL, NULL},
	{"ReplaceFileW", 0x00036C3C, NULL, NULL},
	{"RequestDeviceWakeup", 0x00060B6F, NULL, NULL},
	{"RequestWakeupLatency", 0x00060AF4, NULL, NULL},
	{"ResetEvent", 0x0000A03B, NULL, NULL},
	{"ResetWriteWatch", 0x0005E803, NULL, NULL},
	{"RestoreLastError", 0x0000917A, NULL, NULL},
	{"ResumeThread", 0x000328F7, NULL, NULL},
	{"RtlCaptureContext", 0x00009199, NULL, NULL},
	{"RtlCaptureStackBackTrace", 0x000091B1, NULL, NULL},
	{"RtlFillMemory", 0x000091D0, NULL, NULL},
	{"RtlMoveMemory", 0x000091E4, NULL, NULL},
	{"RtlUnwind", 0x000091F8, NULL, NULL},
	{"RtlZeroMemory", 0x00009208, NULL, NULL},
	{"ScrollConsoleScreenBufferA", 0x00073F21, NULL, NULL},
	{"ScrollConsoleScreenBufferW", 0x00073F45, NULL, NULL},
	{"SearchPathA", 0x000217EA, NULL, NULL},
	{"SearchPathW", 0x0000E6DC, NULL, NULL},
	{"SetCPGlobal", 0x000797C3, NULL, NULL},
	{"SetCalendarInfoA", 0x00075AD6, NULL, NULL},
	{"SetCalendarInfoW", 0x00076D1B, NULL, NULL},
	{"SetClientTimeZoneInformation", 0x00059A31, NULL, NULL},
	{"SetComPlusPackageInstallStatus", 0x0006BB65, NULL, NULL},
	{"SetCommBreak", 0x00065D8C, NULL, NULL},
	{"SetCommConfig", 0x00066EAB, NULL, NULL},
	{"SetCommMask", 0x00065DA4, NULL, NULL},
	{"SetCommState", 0x00065E43, NULL, NULL},
	{"SetCommTimeouts", 0x0006614B, NULL, NULL},
	{"SetComputerNameA", 0x00058234, NULL, NULL},
	{"SetComputerNameExA", 0x0005834C, NULL, NULL},
	{"SetComputerNameExW", 0x000581B3, NULL, NULL},
	{"SetComputerNameW", 0x0005808D, NULL, NULL},
	{"SetConsoleActiveScreenBuffer", 0x00073AA8, NULL, NULL},
	{"SetConsoleCP", 0x00074143, NULL, NULL},
	{"SetConsoleCommandHistoryMode", 0x000709C5, NULL, NULL},
	{"SetConsoleCtrlHandler", 0x0001B58B, NULL, NULL},
	{"SetConsoleCursor", 0x00071EEA, NULL, NULL},
	{"SetConsoleCursorInfo", 0x00073C84, NULL, NULL},
	{"SetConsoleCursorMode", 0x0007477F, NULL, NULL},
	{"SetConsoleCursorPosition", 0x00073C0A, NULL, NULL},
	{"SetConsoleDisplayMode", 0x000720A0, NULL, NULL},
	{"SetConsoleFont", 0x00073FE5, NULL, NULL},
	{"SetConsoleHardwareState", 0x00071CE9, NULL, NULL},
	{"SetConsoleIcon", 0x0007405F, NULL, NULL},
	{"SetConsoleInputExeNameA", 0x00070DA8, NULL, NULL},
	{"SetConsoleInputExeNameW", 0x0001B355, NULL, NULL},
	{"SetConsoleKeyShortcuts", 0x00071D69, NULL, NULL},
	{"SetConsoleLocalEUDC", 0x000746B9, NULL, NULL},
	{"SetConsoleMaximumWindowSize", 0x0007F215, NULL, NULL},
	{"SetConsoleMenuClose", 0x00071E30, NULL, NULL},
	{"SetConsoleMode", 0x0001B1F0, NULL, NULL},
	{"SetConsoleNlsMode", 0x000750D9, NULL, NULL},
	{"SetConsoleNumberOfCommandsA", 0x00070725, NULL, NULL},
	{"SetConsoleNumberOfCommandsW", 0x0007070A, NULL, NULL},
	{"SetConsoleOS2OemFormat", 0x0007493D, NULL, NULL},
	{"SetConsoleOutputCP", 0x00074261, NULL, NULL},
	{"SetConsolePalette", 0x000721C9, NULL, NULL},
	{"SetConsoleScreenBufferSize", 0x00073B90, NULL, NULL},
	{"SetConsoleTextAttribute", 0x00073F69, NULL, NULL},
	{"SetConsoleTitleA", 0x00070A61, NULL, NULL},
	{"SetConsoleTitleW", 0x0002D9BD, NULL, NULL},
	{"SetConsoleWindowInfo", 0x00073D51, NULL, NULL},
	{"SetCriticalSectionSpinCount", 0x0000921C, NULL, NULL},
	{"SetCurrentDirectoryA", 0x000360DD, NULL, NULL},
	{"SetCurrentDirectoryW", 0x0000F2EE, NULL, NULL},
	{"SetDefaultCommConfigA", 0x00066C11, NULL, NULL},
	{"SetDefaultCommConfigW", 0x00066B19, NULL, NULL},
	{"SetDllDirectoryA", 0x0005ED46, NULL, NULL},
	{"SetDllDirectoryW", 0x0005ECB0, NULL, NULL},
	{"SetEndOfFile", 0x00032044, NULL, NULL},
	{"SetEnvironmentVariableA", 0x00033478, NULL, NULL},
	{"SetEnvironmentVariableW", 0x000101BE, NULL, NULL},
	{"SetErrorMode", 0x0000AC0F, NULL, NULL},
	{"SetEvent", 0x0000A017, NULL, NULL},
	{"SetFileApisToANSI", 0x000365F6, NULL, NULL},
	{"SetFileApisToOEM", 0x0001D07E, NULL, NULL},
	{"SetFileAttributesA", 0x00012782, NULL, NULL},
	{"SetFileAttributesW", 0x000314D5, NULL, NULL},
	{"SetFilePointer", 0x00010B8E, NULL, NULL},
	{"SetFilePointerEx", 0x00021057, NULL, NULL},
	{"SetFileShortNameA", 0x0005C8C4, NULL, NULL},
	{"SetFileShortNameW", 0x0005C7F7, NULL, NULL},
	{"SetFileTime", 0x00031CB8, NULL, NULL},
	{"SetFileValidData", 0x0005C7A1, NULL, NULL},
	{"SetFirmwareEnvironmentVariableA", 0x0005E5C7, NULL, NULL},
	{"SetFirmwareEnvironmentVariableW", 0x0005E4AC, NULL, NULL},
	{"SetHandleContext", 0x0002146C, NULL, NULL},
	{"SetHandleCount", 0x0000CC97, NULL, NULL},
	{"SetHandleInformation", 0x0002E18C, NULL, NULL},
	{"SetInformationJobObject", 0x0002CA9F, NULL, NULL},
	{"SetLastConsoleEventActive", 0x000754D3, NULL, NULL},
	{"SetLastError", 0x00009241, NULL, NULL},
	{"SetLocalPrimaryComputerNameA", 0x000592AF, NULL, NULL},
	{"SetLocalPrimaryComputerNameW", 0x00059099, NULL, NULL},
	{"SetLocalTime", 0x00055921, NULL, NULL},
	{"SetLocaleInfoA", 0x000758CB, NULL, NULL},
	{"SetLocaleInfoW", 0x00076E73, NULL, NULL},
	{"SetMailslotInfo", 0x0002CDD8, NULL, NULL},
	{"SetMessageWaitingIndicator", 0x00060BBF, NULL, NULL},
	{"SetNamedPipeHandleState", 0x000313EC, NULL, NULL},
	{"SetPriorityClass", 0x0002C338, NULL, NULL},
	{"SetProcessAffinityMask", 0x000610B0, NULL, NULL},
	{"SetProcessPriorityBoost", 0x000610E0, NULL, NULL},
	{"SetProcessShutdownParameters", 0x0002C8ED, NULL, NULL},
	{"SetProcessWorkingSetSize", 0x000303D0, NULL, NULL},
	{"SetStdHandle", 0x0001DC03, NULL, NULL},
	{"SetSystemPowerState", 0x00060AAB, NULL, NULL},
	{"SetSystemTime", 0x000593BE, NULL, NULL},
	{"SetSystemTimeAdjustment", 0x00059584, NULL, NULL},
	{"SetTapeParameters", 0x0006B21E, NULL, NULL},
	{"SetTapePosition", 0x0006B046, NULL, NULL},
	{"SetTermsrvAppInstallMode", 0x00061BA2, NULL, NULL},
	{"SetThreadAffinityMask", 0x0002FA7A, NULL, NULL},
	{"SetThreadContext", 0x00062AA5, NULL, NULL},
	{"SetThreadExecutionState", 0x000392B5, NULL, NULL},
	{"SetThreadIdealProcessor", 0x00062D48, NULL, NULL},
	{"SetThreadLocale", 0x0001BBBA, NULL, NULL},
	{"SetThreadPriority", 0x0000C108, NULL, NULL},
	{"SetThreadPriorityBoost", 0x00062A30, NULL, NULL},
	{"SetThreadUILanguage", 0x0001B258, NULL, NULL},
	{"SetTimeZoneInformation", 0x0005945E, NULL, NULL},
	{"SetTimerQueueTimer", 0x0002B26E, NULL, NULL},
	{"SetUnhandledExceptionFilter", 0x0004479D, env_w32_hook_SetUnhandledExceptionFilter, NULL},
	{"SetUserGeoID", 0x00078C5C, NULL, NULL},
	{"SetVDMCurrentDirectories", 0x00067714, NULL, NULL},
	{"SetVolumeLabelA", 0x000609ED, NULL, NULL},
	{"SetVolumeLabelW", 0x00060499, NULL, NULL},
	{"SetVolumeMountPointA", 0x0006A091, NULL, NULL},
	{"SetVolumeMountPointW", 0x00069395, NULL, NULL},
	{"SetWaitableTimer", 0x000095F9, NULL, NULL},
	{"SetupComm", 0x000656C7, NULL, NULL},
	{"ShowConsoleCursor", 0x00071F64, NULL, NULL},
	{"SignalObjectAndWait", 0x00036696, NULL, NULL},
	{"SizeofResource", 0x0000BC69, NULL, NULL},
	{"Sleep", 0x00002442, NULL, NULL},
	{"SleepEx", 0x0000239C, NULL, NULL},
	{"SuspendThread", 0x00039732, NULL, NULL},
	{"SwitchToFiber", 0x00010672, NULL, NULL},
	{"SwitchToThread", 0x00032992, NULL, NULL},
	{"SystemTimeToFileTime", 0x00010B1C, NULL, NULL},
	{"SystemTimeToTzSpecificLocalTime", 0x0002E9C1, NULL, NULL},
	{"TerminateJobObject", 0x0006B2F7, NULL, NULL},
	{"TerminateProcess", 0x00001E16, NULL, NULL},
	{"TerminateThread", 0x0001CE03, NULL, NULL},
	{"TermsrvAppInstallMode", 0x0001EFCE, NULL, NULL},
	{"Thread32First", 0x00064062, NULL, NULL},
	{"Thread32Next", 0x00064116, NULL, NULL},
	{"TlsAlloc", 0x00012D9F, NULL, NULL},
	{"TlsFree", 0x000136D7, NULL, NULL},
	{"TlsGetValue", 0x00009740, NULL, NULL},
	{"TlsSetValue", 0x00009BC5, NULL, NULL},
	{"Toolhelp32ReadProcessMemory", 0x00063D24, NULL, NULL},
	{"TransactNamedPipe", 0x000312E5, NULL, NULL},
	{"TransmitCommChar", 0x000661F6, NULL, NULL},
	{"TrimVirtualBuffer", 0x0005EC4E, NULL, NULL},
	{"TryEnterCriticalSection", 0x0000925C, NULL, NULL},
	{"TzSpecificLocalTimeToSystemTime", 0x000595C1, NULL, NULL},
	{"UTRegister", 0x0005EEF0, NULL, NULL},
	{"UTUnRegister", 0x0007E98D, NULL, NULL},
	{"UnhandledExceptionFilter", 0x00062E62, NULL, NULL},
	{"UnlockFile", 0x000322BC, NULL, NULL},
	{"UnlockFileEx", 0x000322FB, NULL, NULL},
	{"UnmapViewOfFile", 0x0000B974, NULL, NULL},
	{"UnregisterConsoleIME", 0x00074B86, NULL, NULL},
	{"UnregisterWait", 0x0002BFF8, NULL, NULL},
	{"UnregisterWaitEx", 0x00030062, NULL, NULL},
	{"UpdateResourceA", 0x0006F6AA, NULL, NULL},
	{"UpdateResourceW", 0x0006F5A3, NULL, NULL},
	{"VDMConsoleOperation", 0x000754E4, NULL, NULL},
	{"VDMOperationStarted", 0x00067E19, NULL, NULL},
	{"ValidateLCType", 0x0007AA95, NULL, NULL},
	{"ValidateLocale", 0x000397F8, NULL, NULL},
	{"VerLanguageNameA", 0x0002EFB9, NULL, NULL},
	{"VerLanguageNameW", 0x0002F041, NULL, NULL},
	{"VerSetConditionMask", 0x0000927D, NULL, NULL},
	{"VerifyConsoleIoHandle", 0x0001AEAA, NULL, NULL},
	{"VerifyVersionInfoA", 0x0005EE46, NULL, NULL},
	{"VerifyVersionInfoW", 0x0001FB26, NULL, NULL},
	{"VirtualAlloc", 0x00009A51, NULL, NULL},
	{"VirtualAllocEx", 0x00009A72, NULL, NULL},
	{"VirtualBufferExceptionHandler", 0x0005EC71, NULL, NULL},
	{"VirtualFree", 0x00009AE4, NULL, NULL},
	{"VirtualFreeEx", 0x00009B02, NULL, NULL},
	{"VirtualLock", 0x0002B13F, NULL, NULL},
	{"VirtualProtect", 0x00001AD0, NULL, NULL},
	{"VirtualProtectEx", 0x00001A5D, NULL, NULL},
	{"VirtualQuery", 0x0000B9D1, NULL, NULL},
	{"VirtualQueryEx", 0x0000B9A0, NULL, NULL},
	{"VirtualUnlock", 0x0005E6DA, NULL, NULL},
	{"WTSGetActiveConsoleSessionId", 0x000132EE, NULL, NULL},
	{"WaitCommEvent", 0x00066280, NULL, NULL},
	{"WaitForDebugEvent", 0x0005A480, NULL, NULL},
	{"WaitForMultipleObjects", 0x0000A05D, NULL, NULL},
	{"WaitForMultipleObjectsEx", 0x0000952A, NULL, NULL},
	{"WaitForSingleObject", 0x00002520, env_w32_hook_WaitForSingleObject, NULL},
	{"WaitForSingleObjectEx", 0x00002540, NULL, NULL},
	{"WaitNamedPipeA", 0x0005FC39, NULL, NULL},
	{"WaitNamedPipeW", 0x0002C664, NULL, NULL},
	{"WideCharToMultiByte", 0x0000A0D4, NULL, NULL},
	{"WinExec", 0x0006136D, env_w32_hook_WinExec, NULL},
	{"WriteConsoleA", 0x0001CF25, NULL, NULL},
	{"WriteConsoleInputA", 0x000723C5, NULL, NULL},
	{"WriteConsoleInputVDMA", 0x00071EA4, NULL, NULL},
	{"WriteConsoleInputVDMW", 0x00071EC7, NULL, NULL},
	{"WriteConsoleInputW", 0x000723E8, NULL, NULL},
	{"WriteConsoleOutputA", 0x00072B45, NULL, NULL},
	{"WriteConsoleOutputAttribute", 0x00072EF1, NULL, NULL},
	{"WriteConsoleOutputCharacterA", 0x00072EA5, NULL, NULL},
	{"WriteConsoleOutputCharacterW", 0x00072ECB, NULL, NULL},
	{"WriteConsoleOutputW", 0x00072B21, NULL, NULL},
	{"WriteConsoleW", 0x00035484, NULL, NULL},
	{"WriteFile", 0x00010D87, env_w32_hook_WriteFile, NULL},
	{"WriteFileEx", 0x0005C701, NULL, NULL},
	{"WriteFileGather", 0x0002DDA5, NULL, NULL},
	{"WritePrivateProfileSectionA", 0x0005BA7C, NULL, NULL},
	{"WritePrivateProfileSectionW", 0x0005BAC3, NULL, NULL},
	{"WritePrivateProfileStringA", 0x00035D54, NULL, NULL},
	{"WritePrivateProfileStringW", 0x0001EE4C, NULL, NULL},
	{"WritePrivateProfileStructA", 0x0005BE23, NULL, NULL},
	{"WritePrivateProfileStructW", 0x0005BF65, NULL, NULL},
	{"WriteProcessMemory", 0x0000220F, NULL, NULL},
	{"WriteProfileSectionA", 0x0005C0F5, NULL, NULL},
	{"WriteProfileSectionW", 0x0005C12E, NULL, NULL},
	{"WriteProfileStringA", 0x0005C0B9, NULL, NULL},
	{"WriteProfileStringW", 0x000332B1, NULL, NULL},
	{"WriteTapemark", 0x0006B188, NULL, NULL},
	{"ZombifyActCtx", 0x0006B6FB, NULL, NULL},
	{"_hread", 0x000353CE, NULL, NULL},
	{"_hwrite", 0x00038AE7, env_w32_hook__hwrite, NULL},
	{"_lclose", 0x00034E64, env_w32_hook__lclose, NULL},
	{"_lcreat", 0x000365A5, env_w32_hook__lcreat, NULL},
	{"_llseek", 0x00035406, NULL, NULL},
	{"_lopen", 0x0005E830, NULL, NULL},
	{"_lread", 0x000353CE, NULL, NULL},
	{"_lwrite", 0x00038AE7, env_w32_hook__lwrite, NULL},
	{"lstrcat", 0x00034D41, NULL, NULL},
	{"lstrcatA", 0x00034D41, NULL, NULL},
	{"lstrcatW", 0x00010F32, NULL, NULL},
	{"lstrcmp", 0x00030D74, NULL, NULL},
	{"lstrcmpA", 0x00030D74, NULL, NULL},
	{"lstrcmpW", 0x0000A9CC, NULL, NULL},
	{"lstrcmpi", 0x0000BAA1, NULL, NULL},
	{"lstrcmpiA", 0x0000BAA1, NULL, NULL},
	{"lstrcmpiW", 0x0000A996, NULL, NULL},
	{"lstrcpy", 0x0000BE01, NULL, NULL},
	{"lstrcpyA", 0x0000BE01, NULL, NULL},
	{"lstrcpyW", 0x0000BA64, NULL, NULL},
	{"lstrcpyn", 0x00010111, NULL, NULL},
	{"lstrcpynA", 0x00010111, NULL, NULL},
	{"lstrcpynW", 0x0000B9EF, NULL, NULL},
	{"lstrlen", 0x0000BDB6, NULL, NULL},
	{"lstrlenA", 0x0000BDB6, NULL, NULL},
	{"lstrlenW", 0x00009A09, NULL, NULL},
	{0,0,NULL},
};

struct emu_env_w32_dll_export ws2_32_exports[] = 
{
	{"accept", 0x00011028, env_w32_hook_accept, NULL},
	{"bind", 0x00003E00, env_w32_hook_bind, NULL},
	{"closesocket", 0x00009639, env_w32_hook_closesocket, NULL},
	{"connect", 0x0000406A, env_w32_hook_connect, NULL},
	{"getpeername", 0x00010B50, NULL, NULL},
	{"getsockname", 0x0000951E, NULL, NULL},
	{"getsockopt", 0x000046C9, NULL, NULL},
	{"htonl", 0x00002BC0, NULL, NULL},
	{"htons", 0x00002B66, NULL, NULL},
	{"ioctlsocket", 0x00004519, NULL, NULL},
	{"inet_addr", 0x00002BF4, NULL, NULL},
	{"inet_ntoa", 0x00003F41, NULL, NULL},
	{"listen", 0x000088D3, env_w32_hook_listen, NULL},
	{"ntohl", 0x00002BC0, NULL, NULL},
	{"ntohs", 0x00002B66, NULL, NULL},
	{"recv", 0x0000615A, env_w32_hook_recv, NULL},
	{"recvfrom", 0x00002D0F, NULL, NULL},
	{"select", 0x00002DC0, NULL, NULL},
	{"send", 0x0000428A, env_w32_hook_send, NULL},
	{"sendto", 0x00002C69, env_w32_hook_sendto, NULL},
	{"setsockopt", 0x00003EA1, NULL, NULL},
	{"shutdown", 0x00010BDE, NULL, NULL},
	{"socket", 0x00003B91, env_w32_hook_socket, NULL},
	{"GetAddrInfoW", 0x00002899, NULL, NULL},
	{"GetNameInfoW", 0x0000C4EC, NULL, NULL},
	{"WSApSetPostRoutine", 0x00011EC9, NULL, NULL},
	{"FreeAddrInfoW", 0x00002B0B, NULL, NULL},
	{"WPUCompleteOverlappedRequest", 0x00011CA7, NULL, NULL},
	{"WSAAccept", 0x00010DA9, NULL, NULL},
	{"WSAAddressToStringA", 0x000091F6, NULL, NULL},
	{"WSAAddressToStringW", 0x000062B2, NULL, NULL},
	{"WSACloseEvent", 0x00004682, NULL, NULL},
	{"WSAConnect", 0x00010C69, NULL, NULL},
	{"WSACreateEvent", 0x000045F7, NULL, NULL},
	{"WSADuplicateSocketA", 0x0000DB82, NULL, NULL},
	{"WSADuplicateSocketW", 0x0000DAF4, NULL, NULL},
	{"WSAEnumNameSpaceProvidersA", 0x0000F9C9, NULL, NULL},
	{"WSAEnumNameSpaceProvidersW", 0x0000FA29, NULL, NULL},
	{"WSAEnumNetworkEvents", 0x00004617, NULL, NULL},
	{"WSAEnumProtocolsA", 0x0000DC47, NULL, NULL},
	{"WSAEnumProtocolsW", 0x0000848C, NULL, NULL},
	{"WSAEventSelect", 0x00004573, NULL, NULL},
	{"WSAGetOverlappedResult", 0x00010D03, NULL, NULL},
	{"WSAGetQOSByName", 0x0000F458, NULL, NULL},
	{"WSAGetServiceClassInfoA", 0x00010428, NULL, NULL},
	{"WSAGetServiceClassInfoW", 0x00010141, NULL, NULL},
	{"WSAGetServiceClassNameByClassIdA", 0x0000FD87, NULL, NULL},
	{"WSAGetServiceClassNameByClassIdW", 0x0000FF69, NULL, NULL},
	{"WSAHtonl", 0x0000BCC9, NULL, NULL},
	{"WSAHtons", 0x0000BDB1, NULL, NULL},
	{"gethostbyaddr", 0x0000E479, NULL, NULL},
	{"gethostbyname", 0x00004FD4, NULL, NULL},
	{"getprotobyname", 0x0000E176, NULL, NULL},
	{"getprotobynumber", 0x0000E0B4, NULL, NULL},
	{"getservbyname", 0x0000E6EB, NULL, NULL},
	{"getservbyport", 0x0000E59D, NULL, NULL},
	{"gethostname", 0x000050C8, NULL, NULL},
	{"WSAInstallServiceClassA", 0x000103A9, NULL, NULL},
	{"WSAInstallServiceClassW", 0x0000FBB1, NULL, NULL},
	{"WSAIoctl", 0x00004489, NULL, NULL},
	{"WSAJoinLeaf", 0x00010F58, NULL, NULL},
	{"WSALookupServiceBeginA", 0x000052AA, NULL, NULL},
	{"WSALookupServiceBeginW", 0x00003307, NULL, NULL},
	{"WSALookupServiceEnd", 0x00003226, NULL, NULL},
	{"WSALookupServiceNextA", 0x0000570E, NULL, NULL},
	{"WSALookupServiceNextW", 0x00002E99, NULL, NULL},
	{"WSANSPIoctl", 0x00004D06, NULL, NULL},
	{"WSANtohl", 0x0000BCC9, NULL, NULL},
	{"WSANtohs", 0x0000BDB1, NULL, NULL},
	{"WSAProviderConfigChange", 0x0000881F, NULL, NULL},
	{"WSARecv", 0x00004318, NULL, NULL},
	{"WSARecvDisconnect", 0x0000F5D6, NULL, NULL},
	{"WSARecvFrom", 0x0000F652, NULL, NULL},
	{"WSARemoveServiceClass", 0x0000FC9C, NULL, NULL},
	{"WSAResetEvent", 0x0000949F, NULL, NULL},
	{"WSASend", 0x00006233, NULL, NULL},
	{"WSASendDisconnect", 0x00010A0A, NULL, NULL},
	{"WSASendTo", 0x00010A95, NULL, NULL},
	{"WSASetEvent", 0x000094B0, NULL, NULL},
	{"WSASetServiceA", 0x000104BA, NULL, NULL},
	{"WSASetServiceW", 0x00010269, NULL, NULL},
	{"WSASocketA", 0x00008769, env_w32_hook_WSASocketA, NULL},
	{"WSASocketW", 0x000039CB, NULL, NULL},
	{"WSAStringToAddressA", 0x000090D8, NULL, NULL},
	{"WSAStringToAddressW", 0x0000281E, NULL, NULL},
	{"WSAWaitForMultipleEvents", 0x0000948E, NULL, NULL},
	{"WSCDeinstallProvider", 0x000119B1, NULL, NULL},
	{"WSCEnableNSProvider", 0x0000EE41, NULL, NULL},
	{"WSCEnumProtocols", 0x00007761, NULL, NULL},
	{"WSCGetProviderPath", 0x00008A27, NULL, NULL},
	{"WSCInstallNameSpace", 0x0000F135, NULL, NULL},
	{"WSCInstallProvider", 0x0001164D, NULL, NULL},
	{"WSCUnInstallNameSpace", 0x0000F301, NULL, NULL},
	{"WSCUpdateProvider", 0x00011279, NULL, NULL},
	{"WSCWriteNameSpaceOrder", 0x0000F001, NULL, NULL},
	{"WSCWriteProviderOrder", 0x00011519, NULL, NULL},
	{"freeaddrinfo", 0x00002B0B, NULL, NULL},
	{"getaddrinfo", 0x00002A6F, NULL, NULL},
	{"getnameinfo", 0x0000C671, NULL, NULL},
	{"WSAAsyncSelect", 0x00010979, NULL, NULL},
	{"WSAAsyncGetHostByAddr", 0x0000EA2B, NULL, NULL},
	{"WSAAsyncGetHostByName", 0x0000E985, NULL, NULL},
	{"WSAAsyncGetProtoByNumber", 0x0000E2AB, NULL, NULL},
	{"WSAAsyncGetProtoByName", 0x0000EAD5, NULL, NULL},
	{"WSAAsyncGetServByPort", 0x0000E8FB, NULL, NULL},
	{"WSAAsyncGetServByName", 0x0000E84F, NULL, NULL},
	{"WSACancelAsyncRequest", 0x0000E32F, NULL, NULL},
	{"WSASetBlockingHook", 0x0000D494, NULL, NULL},
	{"WSAUnhookBlockingHook", 0x0000D4F0, NULL, NULL},
	{"WSAGetLastError", 0x000094DC, NULL, NULL},
	{"WSASetLastError", 0x00002A5E, NULL, NULL},
	{"WSACancelBlockingCall", 0x0000D3F2, NULL, NULL},
	{"WSAIsBlocking", 0x0000D441, NULL, NULL},
	{"WSAStartup", 0x0000664D, env_w32_hook_WSAStartup, NULL},
	{"WSACleanup", 0x00004428, NULL, NULL},
	{"__WSAFDIsSet", 0x00004544, NULL, NULL},
	{"WEP", 0x00012105, NULL, NULL},
	{0,0,NULL},
};

struct emu_env_w32_dll_export wininet_exports[] = 
{
	{"CommitUrlCacheEntryA", 0x00021B82, NULL, NULL},
	{"CommitUrlCacheEntryW", 0x0006F7E3, NULL, NULL},
	{"CreateMD5SSOHash", 0x000487B7, NULL, NULL},
	{"CreateUrlCacheContainerA", 0x0006EA79, NULL, NULL},
	{"CreateUrlCacheContainerW", 0x00070346, NULL, NULL},
	{"CreateUrlCacheEntryA", 0x0006EB0B, NULL, NULL},
	{"CreateUrlCacheEntryW", 0x0006F607, NULL, NULL},
	{"CreateUrlCacheGroup", 0x00070C66, NULL, NULL},
	{"DeleteIE3Cache", 0x00071F68, NULL, NULL},
	{"DeleteUrlCacheContainerA", 0x0006EAC7, NULL, NULL},
	{"DeleteUrlCacheContainerW", 0x000705A4, NULL, NULL},
	{"DeleteUrlCacheEntry", 0x000279AA, NULL, NULL},
	{"DeleteUrlCacheEntryA", 0x000279AA, NULL, NULL},
	{"DeleteUrlCacheEntryW", 0x00070091, NULL, NULL},
	{"DeleteUrlCacheGroup", 0x00070CB1, NULL, NULL},
	{"DetectAutoProxyUrl", 0x0001FA6E, NULL, NULL},
	{"DllInstall", 0x00044D99, NULL, NULL},
	{"FindCloseUrlCache", 0x000216DD, NULL, NULL},
	{"FindFirstUrlCacheContainerA", 0x00021C8F, NULL, NULL},
	{"FindFirstUrlCacheContainerW", 0x00070676, NULL, NULL},
	{"FindFirstUrlCacheEntryA", 0x000052B6, NULL, NULL},
	{"FindFirstUrlCacheEntryExA", 0x0006EDED, NULL, NULL},
	{"FindFirstUrlCacheEntryExW", 0x0006FE59, NULL, NULL},
	{"FindFirstUrlCacheEntryW", 0x00070AFD, NULL, NULL},
	{"FindFirstUrlCacheGroup", 0x00070CF9, NULL, NULL},
	{"FindNextUrlCacheContainerA", 0x00021CDE, NULL, NULL},
	{"FindNextUrlCacheContainerW", 0x00070719, NULL, NULL},
	{"FindNextUrlCacheEntryA", 0x0002186A, NULL, NULL},
	{"FindNextUrlCacheEntryExA", 0x0006EE72, NULL, NULL},
	{"FindNextUrlCacheEntryExW", 0x0006FE8F, NULL, NULL},
	{"FindNextUrlCacheEntryW", 0x00070B27, NULL, NULL},
	{"FindNextUrlCacheGroup", 0x00070D60, NULL, NULL},
	{"ForceNexusLookup", 0x0004878B, NULL, NULL},
	{"ForceNexusLookupExW", 0x0004874C, NULL, NULL},
	{"FreeUrlCacheSpaceA", 0x0006EEDD, NULL, NULL},
	{"FreeUrlCacheSpaceW", 0x0006FECC, NULL, NULL},
	{"FtpCommandA", 0x00053505, NULL, NULL},
	{"FtpCommandW", 0x00054E73, NULL, NULL},
	{"FtpCreateDirectoryA", 0x00052E41, NULL, NULL},
	{"FtpCreateDirectoryW", 0x00054BE0, NULL, NULL},
	{"FtpDeleteFileA", 0x00052AA1, NULL, NULL},
	{"FtpDeleteFileW", 0x000549B6, NULL, NULL},
	{"FtpFindFirstFileA", 0x0005454D, NULL, NULL},
	{"FtpFindFirstFileW", 0x000548BD, NULL, NULL},
	{"FtpGetCurrentDirectoryA", 0x0005335C, NULL, NULL},
	{"FtpGetCurrentDirectoryW", 0x00054D8D, NULL, NULL},
	{"FtpGetFileA", 0x00051DD1, NULL, NULL},
	{"FtpGetFileEx", 0x0005558F, NULL, NULL},
	{"FtpGetFileSize", 0x0005372C, NULL, NULL},
	{"FtpGetFileW", 0x00054F21, NULL, NULL},
	{"FtpOpenFileA", 0x00054573, NULL, NULL},
	{"FtpOpenFileW", 0x00054B49, NULL, NULL},
	{"FtpPutFileA", 0x00051EE7, NULL, NULL},
	{"FtpPutFileEx", 0x0005560D, NULL, NULL},
	{"FtpPutFileW", 0x00055249, NULL, NULL},
	{"FtpRemoveDirectoryA", 0x00053005, NULL, NULL},
	{"FtpRemoveDirectoryW", 0x00054C71, NULL, NULL},
	{"FtpRenameFileA", 0x00052C5B, NULL, NULL},
	{"FtpRenameFileW", 0x00054A47, NULL, NULL},
	{"FtpSetCurrentDirectoryA", 0x000531A7, NULL, NULL},
	{"FtpSetCurrentDirectoryW", 0x00054CFF, NULL, NULL},
	{"GetUrlCacheConfigInfoA", 0x000720B2, NULL, NULL},
	{"GetUrlCacheConfigInfoW", 0x0006F55D, NULL, NULL},
	{"GetUrlCacheEntryInfoA", 0x00021AF9, NULL, NULL},
	{"GetUrlCacheEntryInfoExA", 0x000064BE, NULL, NULL},
	{"GetUrlCacheEntryInfoExW", 0x0002688D, NULL, NULL},
	{"GetUrlCacheEntryInfoW", 0x0006FBD0, NULL, NULL},
	{"GetUrlCacheGroupAttributeA", 0x0006EF9E, NULL, NULL},
	{"GetUrlCacheGroupAttributeW", 0x0006F314, NULL, NULL},
	{"GetUrlCacheHeaderData", 0x000075B2, NULL, NULL},
	{"GopherCreateLocatorA", 0x00058F21, NULL, NULL},
	{"GopherCreateLocatorW", 0x0005A224, NULL, NULL},
	{"GopherFindFirstFileA", 0x0005989F, NULL, NULL},
	{"GopherFindFirstFileW", 0x0005A456, NULL, NULL},
	{"GopherGetAttributeA", 0x0005A212, NULL, NULL},
	{"GopherGetAttributeW", 0x0005A212, NULL, NULL},
	{"GopherGetLocatorTypeA", 0x0005914D, NULL, NULL},
	{"GopherGetLocatorTypeW", 0x0005A3DA, NULL, NULL},
	{"GopherOpenFileA", 0x00059DD4, NULL, NULL},
	{"GopherOpenFileW", 0x0005A60D, NULL, NULL},
	{"HttpAddRequestHeadersA", 0x000140B2, NULL, NULL},
	{"HttpAddRequestHeadersW", 0x0001EEF5, NULL, NULL},
	{"HttpCheckDavCompliance", 0x0006189D, NULL, NULL},
	{"HttpEndRequestA", 0x00061E8F, NULL, NULL},
	{"HttpEndRequestW", 0x00061EC1, NULL, NULL},
	{"HttpOpenRequestA", 0x000136AD, NULL, NULL},
	{"HttpOpenRequestW", 0x0001F3F9, NULL, NULL},
	{"HttpQueryInfoA", 0x0001780A, NULL, NULL},
	{"HttpQueryInfoW", 0x00025FCA, NULL, NULL},
	{"HttpSendRequestA", 0x00016249, NULL, NULL},
	{"HttpSendRequestExA", 0x00061E29, NULL, NULL},
	{"HttpSendRequestExW", 0x0001E9C1, NULL, NULL},
	{"HttpSendRequestW", 0x00061D24, NULL, NULL},
	{"IncrementUrlCacheHeaderData", 0x00070BAE, NULL, NULL},
	{"InternetAlgIdToStringA", 0x0007A4E4, NULL, NULL},
	{"InternetAlgIdToStringW", 0x00049995, NULL, NULL},
	{"InternetAttemptConnect", 0x00047684, NULL, NULL},
	{"InternetAutodial", 0x000429F8, NULL, NULL},
	{"InternetAutodialCallback", 0x00042E89, NULL, NULL},
	{"InternetAutodialHangup", 0x00042D5B, NULL, NULL},
	{"InternetCanonicalizeUrlA", 0x0001302F, NULL, NULL},
	{"InternetCanonicalizeUrlW", 0x00021922, NULL, NULL},
	{"InternetCheckConnectionA", 0x000482FA, NULL, NULL},
	{"InternetCheckConnectionW", 0x000497D2, NULL, NULL},
	{"InternetClearAllPerSiteCookieDecisions", 0x00062BE2, NULL, NULL},
	{"InternetCloseHandle", 0x00014D6C, NULL, NULL},
	{"InternetCombineUrlA", 0x000242E0, NULL, NULL},
	{"InternetCombineUrlW", 0x00048B07, NULL, NULL},
	{"InternetConfirmZoneCrossing", 0x0007C751, NULL, NULL},
	{"InternetConfirmZoneCrossingA", 0x0007C751, NULL, NULL},
	{"InternetConfirmZoneCrossingW", 0x0007C79D, NULL, NULL},
	{"InternetConnectA", 0x000130C3, NULL, NULL},
	{"InternetConnectW", 0x0001EE00, NULL, NULL},
	{"InternetCrackUrlA", 0x000173DC, NULL, NULL},
	{"InternetCrackUrlW", 0x00048CCE, NULL, NULL},
	{"InternetCreateUrlA", 0x0001256F, NULL, NULL},
	{"InternetCreateUrlW", 0x0004900B, NULL, NULL},
	{"InternetDial", 0x0004286A, NULL, NULL},
	{"InternetDialA", 0x0004286A, NULL, NULL},
	{"InternetDialW", 0x00042317, NULL, NULL},
	{"InternetEnumPerSiteCookieDecisionA", 0x00062AC0, NULL, NULL},
	{"InternetEnumPerSiteCookieDecisionW", 0x00062B39, NULL, NULL},
	{"InternetErrorDlg", 0x0007C34D, NULL, NULL},
	{"InternetFindNextFileA", 0x00047E88, NULL, NULL},
	{"InternetFindNextFileW", 0x00048BB2, NULL, NULL},
	{"InternetFortezzaCommand", 0x0004D5B6, NULL, NULL},
	{"InternetGetCertByURL", 0x000473FC, NULL, NULL},
	{"InternetGetCertByURLA", 0x000473FC, NULL, NULL},
	{"InternetGetConnectedState", 0x00025C2E, NULL, NULL},
	{"InternetGetConnectedStateEx", 0x0002721D, NULL, NULL},
	{"InternetGetConnectedStateExA", 0x0002721D, NULL, NULL},
	{"InternetGetConnectedStateExW", 0x0002363E, NULL, NULL},
	{"InternetGetCookieA", 0x00064BA9, NULL, NULL},
	{"InternetGetCookieExA", 0x00029506, NULL, NULL},
	{"InternetGetCookieExW", 0x0002941B, NULL, NULL},
	{"InternetGetCookieW", 0x000271FA, NULL, NULL},
	{"InternetGetLastResponseInfoA", 0x000474DC, NULL, NULL},
	{"InternetGetLastResponseInfoW", 0x00049723, NULL, NULL},
	{"InternetGetPerSiteCookieDecisionA", 0x0006296E, NULL, NULL},
	{"InternetGetPerSiteCookieDecisionW", 0x000629BF, NULL, NULL},
	{"InternetGoOnline", 0x000431EA, NULL, NULL},
	{"InternetGoOnlineA", 0x000431EA, NULL, NULL},
	{"InternetGoOnlineW", 0x000430B1, NULL, NULL},
	{"InternetHangUp", 0x000428ED, NULL, NULL},
	{"InternetInitializeAutoProxyDll", 0x0005D45B, NULL, NULL},
	{"InternetLockRequestFile", 0x0001C624, NULL, NULL},
	{"InternetOpenA", 0x000158BA, NULL, NULL},
	{"InternetOpenUrlA", 0x00015B6D, NULL, NULL},
	{"InternetOpenUrlW", 0x00025B52, NULL, NULL},
	{"InternetOpenW", 0x0000AEFD, NULL, NULL},
	{"InternetQueryDataAvailable", 0x00028A17, NULL, NULL},
	{"InternetQueryFortezzaStatus", 0x0004D555, NULL, NULL},
	{"InternetQueryOptionA", 0x00007138, NULL, NULL},
	{"InternetQueryOptionW", 0x00025A3F, NULL, NULL},
	{"InternetReadFile", 0x000180F4, NULL, NULL},
	{"InternetReadFileExA", 0x00048160, NULL, NULL},
	{"InternetReadFileExW", 0x00047459, NULL, NULL},
	{"InternetSecurityProtocolToStringA", 0x0007A588, NULL, NULL},
	{"InternetSecurityProtocolToStringW", 0x00049A6B, NULL, NULL},
	{"InternetSetCookieA", 0x00064D8F, NULL, NULL},
	{"InternetSetCookieExA", 0x000650D3, NULL, NULL},
	{"InternetSetCookieExW", 0x00064DBA, NULL, NULL},
	{"InternetSetCookieW", 0x00065136, NULL, NULL},
	{"InternetSetDialState", 0x000420C3, NULL, NULL},
	{"InternetSetDialStateA", 0x000420C3, NULL, NULL},
	{"InternetSetDialStateW", 0x000420E6, NULL, NULL},
	{"InternetSetFilePointer", 0x0004746B, NULL, NULL},
	{"InternetSetOptionA", 0x0000B1A5, NULL, NULL},
	{"InternetSetOptionExA", 0x00049CA8, NULL, NULL},
	{"InternetSetOptionExW", 0x00049CD9, NULL, NULL},
	{"InternetSetOptionW", 0x0000BBED, NULL, NULL},
	{"InternetSetPerSiteCookieDecisionA", 0x00062806, NULL, NULL},
	{"InternetSetPerSiteCookieDecisionW", 0x00062880, NULL, NULL},
	{"InternetSetStatusCallback", 0x00029084, NULL, NULL},
	{"InternetSetStatusCallbackA", 0x00029084, NULL, NULL},
	{"InternetSetStatusCallbackW", 0x00048CB3, NULL, NULL},
	{"InternetShowSecurityInfoByURL", 0x0004799D, NULL, NULL},
	{"InternetShowSecurityInfoByURLA", 0x0004799D, NULL, NULL},
	{"InternetShowSecurityInfoByURLW", 0x000498B5, NULL, NULL},
	{"InternetTimeFromSystemTime", 0x00029D18, NULL, NULL},
	{"InternetTimeFromSystemTimeA", 0x00029D18, NULL, NULL},
	{"InternetTimeFromSystemTimeW", 0x0006547A, NULL, NULL},
	{"InternetTimeToSystemTime", 0x0006542B, NULL, NULL},
	{"InternetTimeToSystemTimeA", 0x0006542B, NULL, NULL},
	{"InternetTimeToSystemTimeW", 0x00065517, NULL, NULL},
	{"InternetUnlockRequestFile", 0x0001B9CE, NULL, NULL},
	{"InternetWriteFile", 0x00047C19, NULL, NULL},
	{"InternetWriteFileExA", 0x00047459, NULL, NULL},
	{"InternetWriteFileExW", 0x00047459, NULL, NULL},
	{"IsHostInProxyBypassList", 0x00023350, NULL, NULL},
	{"IsUrlCacheEntryExpiredA", 0x0006F07A, NULL, NULL},
	{"IsUrlCacheEntryExpiredW", 0x00070170, NULL, NULL},
	{"LoadUrlCacheContent", 0x00070BDE, NULL, NULL},
	{"ParseX509EncodedCertificateForListBoxEntry", 0x0007A686, NULL, NULL},
	{"PrivacyGetZonePreferenceW", 0x00061077, NULL, NULL},
	{"PrivacySetZonePreferenceW", 0x00060EFB, NULL, NULL},
	{"ReadUrlCacheEntryStream", 0x0002986B, NULL, NULL},
	{"RegisterUrlCacheNotification", 0x00070DB3, NULL, NULL},
	{"ResumeSuspendedDownload", 0x0004C656, NULL, NULL},
	{"RetrieveUrlCacheEntryFileA", 0x0006EB8B, NULL, NULL},
	{"RetrieveUrlCacheEntryFileW", 0x000708F9, NULL, NULL},
	{"RetrieveUrlCacheEntryStreamA", 0x0006EC05, NULL, NULL},
	{"RetrieveUrlCacheEntryStreamW", 0x0007091C, NULL, NULL},
	{"RunOnceUrlCache", 0x0007111D, NULL, NULL},
	{"SetUrlCacheConfigInfoA", 0x00072FB8, NULL, NULL},
	{"SetUrlCacheConfigInfoW", 0x0006F5F5, NULL, NULL},
	{"SetUrlCacheEntryGroup", 0x0006EF25, NULL, NULL},
	{"SetUrlCacheEntryGroupA", 0x0006EF25, NULL, NULL},
	{"SetUrlCacheEntryGroupW", 0x00070255, NULL, NULL},
	{"SetUrlCacheEntryInfoA", 0x0006ED82, NULL, NULL},
	{"SetUrlCacheEntryInfoW", 0x0006FBF2, NULL, NULL},
	{"SetUrlCacheGroupAttributeA", 0x0006F018, NULL, NULL},
	{"SetUrlCacheGroupAttributeW", 0x0006F3C9, NULL, NULL},
	{"SetUrlCacheHeaderData", 0x00070B7E, NULL, NULL},
	{"ShowCertificate", 0x0007A66E, NULL, NULL},
	{"ShowClientAuthCerts", 0x0007A67B, NULL, NULL},
	{"ShowSecurityInfo", 0x0007B135, NULL, NULL},
	{"ShowX509EncodedCertificate", 0x0007BACB, NULL, NULL},
	{"UnlockUrlCacheEntryFile", 0x00027D5C, NULL, NULL},
	{"UnlockUrlCacheEntryFileA", 0x00027D5C, NULL, NULL},
	{"UnlockUrlCacheEntryFileW", 0x0006FFAF, NULL, NULL},
	{"UnlockUrlCacheEntryStream", 0x00027CC2, NULL, NULL},
	{"UpdateUrlCacheContentPath", 0x00070C50, NULL, NULL},
	{"UrlZonesDetach", 0x00069802, NULL, NULL},
	{"_GetFileExtensionFromUrl", 0x0004DE5F, NULL, NULL},
	{0,0,NULL},
};

struct emu_env_w32_dll_export msvcrt_exports[] = 
{

	{"??0__non_rtti_object@@QAE@ABV0@@Z", 0x0001164B, NULL, NULL},
	{"??0__non_rtti_object@@QAE@PBD@Z", 0x00011629, NULL, NULL},
	{"??0bad_cast@@AAE@PBQBD@Z", 0x000115C2, NULL, NULL},
	{"??0bad_cast@@QAE@ABQBD@Z", 0x000115C2, NULL, NULL},
	{"??0bad_cast@@QAE@ABV0@@Z", 0x00011590, NULL, NULL},
	{"??0bad_cast@@QAE@PBD@Z", 0x0001156D, NULL, NULL},
	{"??0bad_typeid@@QAE@ABV0@@Z", 0x00011607, NULL, NULL},
	{"??0bad_typeid@@QAE@PBD@Z", 0x000115E4, NULL, NULL},
	{"??0exception@@QAE@ABQBD@Z", 0x00011498, NULL, NULL},
	{"??0exception@@QAE@ABV0@@Z", 0x000114E7, NULL, NULL},
	{"??0exception@@QAE@XZ", 0x00011482, NULL, NULL},
	{"??1__non_rtti_object@@UAE@XZ", 0x0001166D, NULL, NULL},
	{"??1bad_cast@@UAE@XZ", 0x000115B2, NULL, NULL},
	{"??1bad_typeid@@UAE@XZ", 0x0001166D, NULL, NULL},
	{"??1exception@@UAE@XZ", 0x00011540, NULL, NULL},
	{"??1type_info@@UAE@XZ", 0x00011868, NULL, NULL},
	{"??2@YAPAXI@Z", 0x00019CC5, NULL, NULL},
	{"??3@YAXPAX@Z", 0x00019CDD, NULL, NULL},
	{"??4__non_rtti_object@@QAEAAV0@ABV0@@Z", 0x0001184C, NULL, NULL},
	{"??4bad_cast@@QAEAAV0@ABV0@@Z", 0x00011830, NULL, NULL},
	{"??4bad_typeid@@QAEAAV0@ABV0@@Z", 0x00011830, NULL, NULL},
	{"??4exception@@QAEAAV0@ABV0@@Z", 0x00011808, NULL, NULL},
	{"??8type_info@@QBEHABV0@@Z", 0x00011898, NULL, NULL},
	{"??9type_info@@QBEHABV0@@Z", 0x000118E1, NULL, NULL},
	{"??_7__non_rtti_object@@6B@", 0x000013F8, NULL, NULL},
	{"??_7bad_cast@@6B@", 0x000013E0, NULL, NULL},
	{"??_7bad_typeid@@6B@", 0x000013EC, NULL, NULL},
	{"??_7exception@@6B@", 0x000013C0, NULL, NULL},
	{"??_E__non_rtti_object@@UAEPAXI@Z", 0x0001178F, NULL, NULL},
	{"??_Ebad_cast@@UAEPAXI@Z", 0x0001172C, NULL, NULL},
	{"??_Ebad_typeid@@UAEPAXI@Z", 0x0001178F, NULL, NULL},
	{"??_Eexception@@UAEPAXI@Z", 0x000116A3, NULL, NULL},
	{"??_Fbad_cast@@QAEXXZ", 0x000116F6, NULL, NULL},
	{"??_Fbad_typeid@@QAEXXZ", 0x0001177F, NULL, NULL},
	{"??_G__non_rtti_object@@UAEPAXI@Z", 0x000117E2, NULL, NULL},
	{"??_Gbad_cast@@UAEPAXI@Z", 0x00011706, NULL, NULL},
	{"??_Gbad_typeid@@UAEPAXI@Z", 0x000117E2, NULL, NULL},
	{"??_Gexception@@UAEPAXI@Z", 0x0001167D, NULL, NULL},
	{"??_U@YAPAXI@Z", 0x00019CED, NULL, NULL},
	{"??_V@YAXPAX@Z", 0x00019CFD, NULL, NULL},
	{"__uncaught_exception", 0x00011BB1, NULL, NULL},
	{"?_query_new_handler@@YAP6AHI@ZXZ", 0x00019D3B, NULL, NULL},
	{"?_query_new_mode@@YAHXZ", 0x00019D94, NULL, NULL},
	{"?_set_new_handler@@YAP6AHI@ZP6AHI@Z@Z", 0x00019D0D, NULL, NULL},
	{"?_set_new_mode@@YAHH@Z", 0x00019D6C, NULL, NULL},
	{"?_set_se_translator@@YAP6AXIPAU_EXCEPTION_POINTERS@@@ZP6AXI0@Z@Z", 0x000125AD, NULL, NULL},
	{"?before@type_info@@QBEHABV1@@Z", 0x0001192A, NULL, NULL},
	{"?name@type_info@@QBEPBDXZ", 0x000125D0, NULL, NULL},
	{"?raw_name@type_info@@QBEPBDXZ", 0x00011973, NULL, NULL},
	{"?set_new_handler@@YAP6AXXZP6AXXZ@Z", 0x00019D9F, NULL, NULL},
	{"?set_terminate@@YAP6AXXZP6AXXZ@Z", 0x00012567, NULL, NULL},
	{"?set_unexpected@@YAP6AXXZP6AXXZ@Z", 0x0001258A, NULL, NULL},
	{"?terminate@@YAXXZ", 0x0001266D, NULL, NULL},
	{"?unexpected@@YAXXZ", 0x000126A7, NULL, NULL},
	{"?what@exception@@UBEPBDXZ", 0x0001155B, NULL, NULL},
	{"$I10_OUTPUT", 0x0003B2ED, NULL, NULL},
	{"_CIacos", 0x0003CA40, NULL, NULL},
	{"_CIasin", 0x0003CB10, NULL, NULL},
	{"_CIatan", 0x0003CC20, NULL, NULL},
	{"_CIatan2", 0x0003CD0A, NULL, NULL},
	{"_CIcos", 0x0003CD20, NULL, NULL},
	{"_CIcosh", 0x0003CE02, NULL, NULL},
	{"_CIexp", 0x0003CE5C, NULL, NULL},
	{"_CIfmod", 0x0003CEBA, NULL, NULL},
	{"_CIlog", 0x0003CF20, NULL, NULL},
	{"_CIlog10", 0x0003D080, NULL, NULL},
	{"_CIpow", 0x0003D1E0, NULL, NULL},
	{"_CIsin", 0x0003D430, NULL, NULL},
	{"_CIsinh", 0x0003CDF8, NULL, NULL},
	{"_CIsqrt", 0x0003D4F0, NULL, NULL},
	{"_CItan", 0x0003D5B0, NULL, NULL},
	{"_CItanh", 0x0003CE09, NULL, NULL},
	{"_CxxThrowException", 0x000126F6, NULL, NULL},
	{"_EH_prolog", 0x00012738, NULL, NULL},
	{"_Getdays", 0x00038450, NULL, NULL},
	{"_Getmonths", 0x00038509, NULL, NULL},
	{"_Gettnames", 0x000385C7, NULL, NULL},
	{"_HUGE", 0x000504F0, NULL, NULL},
	{"_Strftime", 0x00039094, NULL, NULL},
	{"_XcptFilter", 0x00022DAE, NULL, NULL},
	{"__CxxCallUnwindDtor", 0x00011D1D, NULL, NULL},
	{"__CxxDetectRethrow", 0x00011C33, NULL, NULL},
	{"__CxxExceptionFilter", 0x0001207D, NULL, NULL},
	{"__CxxFrameHandler", 0x000127FA, NULL, NULL},
	{"__CxxLongjmpUnwind", 0x00012837, NULL, NULL},
	{"__CxxQueryExceptionSize", 0x00011D14, NULL, NULL},
	{"__CxxRegisterExceptionObject", 0x00011BC9, NULL, NULL},
	{"__CxxUnregisterExceptionObject", 0x00011C8B, NULL, NULL},
	{"__DestructExceptionObject", 0x00011B41, NULL, NULL},
	{"__RTCastToVoid", 0x00012D19, NULL, NULL},
	{"__RTDynamicCast", 0x00013079, NULL, NULL},
	{"__RTtypeid", 0x00012BBA, NULL, NULL},
	{"__STRINGTOLD", 0x0003B9CE, NULL, NULL},
	{"___lc_codepage_func", 0x000230F4, NULL, NULL},
	{"___lc_handle_func", 0x00023112, NULL, NULL},
	{"___mb_cur_max_func", 0x000230E9, NULL, NULL},
	{"___setlc_active_func", 0x00023130, NULL, NULL},
	{"___unguarded_readlc_active_add_func", 0x0002313B, NULL, NULL},
	{"__argc", 0x00051A28, NULL, NULL},
	{"__argv", 0x00051A2C, NULL, NULL},
	{"__badioinfo", 0x0004F310, NULL, NULL},
	{"__crtCompareStringA", 0x00023DA5, NULL, NULL},
	{"__crtCompareStringW", 0x00024157, NULL, NULL},
	{"__crtGetLocaleInfoW", 0x000243AE, NULL, NULL},
	{"__crtGetStringTypeW", 0x000244E3, NULL, NULL},
	{"__crtLCMapStringA", 0x00024715, NULL, NULL},
	{"__crtLCMapStringW", 0x00024AE6, NULL, NULL},
	{"__dllonexit", 0x00024E51, NULL, NULL},
	{"__doserrno", 0x0000F2CA, NULL, NULL},
	{"__fpecode", 0x00024FB8, NULL, NULL},
	{"__getmainargs", 0x0000EEEB, NULL, NULL},
	{"__initenv", 0x00051A38, NULL, NULL},
	{"__iob_func", 0x0000F207, NULL, NULL},
	{"__isascii", 0x0000BE0A, NULL, NULL},
	{"__iscsym", 0x0000BE57, NULL, NULL},
	{"__iscsymf", 0x0000BE33, NULL, NULL},
	{"__lc_codepage", 0x000518B4, NULL, NULL},
	{"__lc_collate_cp", 0x000518B8, NULL, NULL},
	{"__lc_handle", 0x0005189C, NULL, NULL},
	{"__lconv_init", 0x0002530B, NULL, NULL},
	{"__mb_cur_max", 0x0004F97C, NULL, NULL},
	{"__p___argc", 0x0000F183, NULL, NULL},
	{"__p___argv", 0x0000F18E, NULL, NULL},
	{"__p___initenv", 0x0000F1F1, NULL, NULL},
	{"__p___mb_cur_max", 0x0000F228, NULL, NULL},
	{"__p___wargv", 0x0000F199, NULL, NULL},
	{"__p___winitenv", 0x0000F1FC, NULL, NULL},
	{"__p__acmdln", 0x0000F162, NULL, NULL},
	{"__p__amblksiz", 0x0000F178, NULL, NULL},
	{"__p__commode", 0x0000F1A4, NULL, NULL},
	{"__p__daylight", 0x0000F1AF, NULL, NULL},
	{"__p__dstbias", 0x0000F1BA, NULL, NULL},
	{"__p__environ", 0x0000F1C5, NULL, NULL},
	{"__p__fileinfo", 0x0000F1E6, NULL, NULL},
	{"__p__fmode", 0x0000F1DB, NULL, NULL},
	{"__p__iob", 0x0000F207, NULL, NULL},
	{"__p__mbcasemap", 0x0000F21D, NULL, NULL},
	{"__p__mbctype", 0x0000F212, NULL, NULL},
	{"__p__osver", 0x0000F233, NULL, NULL},
	{"__p__pctype", 0x0000F23E, NULL, NULL},
	{"__p__pgmptr", 0x0000F254, NULL, NULL},
	{"__p__pwctype", 0x0000F249, NULL, NULL},
	{"__p__timezone", 0x0000F26A, NULL, NULL},
	{"__p__tzname", 0x0000F275, NULL, NULL},
	{"__p__wcmdln", 0x0000F16D, NULL, NULL},
	{"__p__wenviron", 0x0000F1D0, NULL, NULL},
	{"__p__winmajor", 0x0000F280, NULL, NULL},
	{"__p__winminor", 0x0000F28B, NULL, NULL},
	{"__p__winver", 0x0000F296, NULL, NULL},
	{"__p__wpgmptr", 0x0000F25F, NULL, NULL},
	{"__pctype_func", 0x0002533D, NULL, NULL},
	{"__pioinfo", 0x00052440, NULL, NULL},
	{"__pxcptinfoptrs", 0x00024FC6, NULL, NULL},
	{"__set_app_type", 0x0002537C, NULL, NULL},
	{"__setlc_active", 0x0005278C, NULL, NULL},
	{"__setusermatherr", 0x0003D675, NULL, NULL},
	{"__threadhandle", 0x0002A11A, NULL, NULL},
	{"__threadid", 0x0002A10F, NULL, NULL},
	{"__toascii", 0x0000BE21, NULL, NULL},
	{"__unDName", 0x00017897, NULL, NULL},
	{"__unDNameEx", 0x0001793C, NULL, NULL},
	{"__unguarded_readlc_active", 0x00052790, NULL, NULL},
	{"__wargv", 0x00051A30, NULL, NULL},
	{"__wcserror", 0x00025390, NULL, NULL},
	{"__wgetmainargs", 0x0000EE8A, NULL, NULL},
	{"__winitenv", 0x00051A40, NULL, NULL},
	{"_abnormal_termination", 0x00025517, NULL, NULL},
	{"_access", 0x0000F355, NULL, NULL},
	{"_acmdln", 0x000517AC, NULL, NULL},
	{"_adj_fdiv_m16i", 0x0003DD24, NULL, NULL},
	{"_adj_fdiv_m32", 0x0003DC8C, NULL, NULL},
	{"_adj_fdiv_m32i", 0x0003DD58, NULL, NULL},
	{"_adj_fdiv_m64", 0x0003DCD8, NULL, NULL},
	{"_adj_fdiv_r", 0x0003D7C7, NULL, NULL},
	{"_adj_fdivr_m16i", 0x0003DE24, NULL, NULL},
	{"_adj_fdivr_m32", 0x0003DD8C, NULL, NULL},
	{"_adj_fdivr_m32i", 0x0003DE58, NULL, NULL},
	{"_adj_fdivr_m64", 0x0003DDD8, NULL, NULL},
	{"_adj_fpatan", 0x0003E435, NULL, NULL},
	{"_adj_fprem", 0x0003E0BC, NULL, NULL},
	{"_adj_fprem1", 0x0003E374, NULL, NULL},
	{"_adj_fptan", 0x0003E438, NULL, NULL},
	{"_adjust_fdiv", 0x000523D8, NULL, NULL},
	{"_aexit_rtn", 0x0004D000, NULL, NULL},
	{"_aligned_free", 0x00019E33, NULL, NULL},
	{"_aligned_malloc", 0x00019E52, NULL, NULL},
	{"_aligned_offset_malloc", 0x00019DAF, NULL, NULL},
	{"_aligned_offset_realloc", 0x00019E6E, NULL, NULL},
	{"_aligned_realloc", 0x00019FC6, NULL, NULL},
	{"_amsg_exit", 0x0000F125, NULL, NULL},
	{"_assert", 0x00025566, NULL, NULL},
	{"_atodbl", 0x0003BE70, NULL, NULL},
	{"_atoi64", 0x0000BF28, NULL, NULL},
	{"_atoldbl", 0x0003BEB8, NULL, NULL},
	{"_beep", 0x0000E10A, NULL, NULL},
	{"_beginthread", 0x0002A26E, NULL, NULL},
	{"_beginthreadex", 0x0002A3DB, NULL, NULL},
	{"_c_exit", 0x00029ECE, NULL, NULL},
	{"_cabs", 0x0003E6E8, NULL, NULL},
	{"_callnewh", 0x00019D46, NULL, NULL},
	{"_cexit", 0x00029EB6, NULL, NULL},
	{"_cgets", 0x0001CAB0, NULL, NULL},
	{"_cgetws", 0x0001CB91, NULL, NULL},
	{"_chdir", 0x0000F3A5, NULL, NULL},
	{"_chdrive", 0x0000F4AC, NULL, NULL},
	{"_chgsign", 0x0003E736, NULL, NULL},
	{"_chkesp", 0x00025BBC, NULL, NULL},
	{"_chmod", 0x0000F53F, NULL, NULL},
	{"_chsize", 0x0001CFAE, NULL, NULL},
	{"_clearfp", 0x0003EDDA, NULL, NULL},
	{"_close", 0x0001D0D7, NULL, NULL},
	{"_commit", 0x0001D177, NULL, NULL},
	{"_commode", 0x000521FC, NULL, NULL},
	{"_control87", 0x0003EDF5, NULL, NULL},
	{"_controlfp", 0x0003EE2F, NULL, NULL},
	{"_copysign", 0x0003E70E, NULL, NULL},
	{"_cprintf", 0x0002C388, NULL, NULL},
	{"_cputs", 0x0001D238, NULL, NULL},
	{"_cputws", 0x0001D35D, NULL, NULL},
	{"_creat", 0x0001D40F, NULL, NULL},
	{"_cscanf", 0x0002D0BB, NULL, NULL},
	{"_ctime64", 0x000390EF, NULL, NULL},
	{"_ctype", 0x000028A0, NULL, NULL},
	{"_cwait", 0x000181BD, NULL, NULL},
	{"_cwprintf", 0x0002DB3B, NULL, NULL},
	{"_cwscanf", 0x0002E94F, NULL, NULL},
	{"_daylight", 0x0004FFD4, NULL, NULL},
	{"_dstbias", 0x0004FFD8, NULL, NULL},
	{"_dup", 0x0001D4F4, NULL, NULL},
	{"_dup2", 0x0001D70D, NULL, NULL},
	{"_ecvt", 0x0000C0A2, NULL, NULL},
	{"_endthread", 0x0002A194, NULL, NULL},
	{"_endthreadex", 0x0002A307, NULL, NULL},
	{"_environ", 0x00051A34, NULL, NULL},
	{"_eof", 0x0001D7DD, NULL, NULL},
	{"_errno", 0x0000F2BC, NULL, NULL},
	{"_except_handler2", 0x00025BDC, NULL, NULL},
	{"_except_handler3", 0x00025C94, NULL, NULL},
	{"_execl", 0x00018253, NULL, NULL},
	{"_execle", 0x00018270, NULL, NULL},
	{"_execlp", 0x00018299, NULL, NULL},
	{"_execlpe", 0x000182B3, NULL, NULL},
	{"_execv", 0x000182DC, env_w32_hook__execv, NULL},
	{"_execve", 0x00018351, NULL, NULL},
	{"_execvp", 0x000184DF, NULL, NULL},
	{"_execvpe", 0x000184FB, NULL, NULL},
	{"_exit", 0x00029E9A, NULL, NULL},
	{"_expand", 0x00019FE5, NULL, NULL},
	{"_fcloseall", 0x0002E968, NULL, NULL},
	{"_fcvt", 0x0000C054, NULL, NULL},
	{"_fdopen", 0x0002EA08, NULL, NULL},
	{"_fgetchar", 0x0002EB2A, NULL, NULL},
	{"_fgetwchar", 0x0002EB45, NULL, NULL},
	{"_filbuf", 0x0002EB60, NULL, NULL},
	{"_fileinfo", 0x0004D2A0, NULL, NULL},
	{"_filelength", 0x0001D8E2, NULL, NULL},
	{"_filelengthi64", 0x0001D9BB, NULL, NULL},
	{"_fileno", 0x0002EC4B, NULL, NULL},
	{"_findclose", 0x0000E122, NULL, NULL},
	{"_findfirst", 0x0000E1B8, NULL, NULL},
	{"_findfirst64", 0x0000E3F8, NULL, NULL},
	{"_findfirsti64", 0x0000E61B, NULL, NULL},
	{"_findnext", 0x0000E2A4, NULL, NULL},
	{"_findnext64", 0x0000E50C, NULL, NULL},
	{"_findnexti64", 0x0000E726, NULL, NULL},
	{"_finite", 0x0003EB1E, NULL, NULL},
	{"_flsbuf", 0x0002EC5D, NULL, NULL},
	{"_flushall", 0x0002EF4B, NULL, NULL},
	{"_fmode", 0x0005185C, NULL, NULL},
	{"_fpclass", 0x0003EB74, NULL, NULL},
	{"_fpieee_flt", 0x0003F38E, NULL, NULL},
	{"_fpreset", 0x0003EC17, NULL, NULL},
	{"_fputchar", 0x0002EF59, NULL, NULL},
	{"_fputwchar", 0x0002EF84, NULL, NULL},
	{"_fsopen", 0x0002EFAF, NULL, NULL},
	{"_fstat", 0x0001DAB4, NULL, NULL},
	{"_fstat64", 0x0001DD75, NULL, NULL},
	{"_fstati64", 0x0001E07A, NULL, NULL},
	{"_ftime", 0x00039113, NULL, NULL},
	{"_ftime64", 0x00039224, NULL, NULL},
	{"_ftol", 0x0003FA10, NULL, NULL},
	{"_fullpath", 0x0000F589, NULL, NULL},
	{"_futime", 0x00039351, NULL, NULL},
	{"_futime64", 0x000394DE, NULL, NULL},
	{"_gcvt", 0x0000C0FA, NULL, NULL},
	{"_get_heap_handle", 0x0001A401, NULL, NULL},
	{"_get_osfhandle", 0x0001E468, NULL, NULL},
	{"_get_sbh_threshold", 0x0001A40C, NULL, NULL},
	{"_getch", 0x0001EAA1, NULL, NULL},
	{"_getche", 0x0001EAC4, NULL, NULL},
	{"_getcwd", 0x0000F785, NULL, NULL},
	{"_getdcwd", 0x0000F7D0, NULL, NULL},
	{"_getdiskfree", 0x0000E82C, NULL, NULL},
	{"_getdllprocaddr", 0x000186B2, NULL, NULL},
	{"_getdrive", 0x0000F452, NULL, NULL},
	{"_getdrives", 0x0000E885, NULL, NULL},
	{"_getmaxstdio", 0x0002F12C, NULL, NULL},
	{"_getmbcp", 0x00020838, NULL, NULL},
	{"_getpid", 0x0000F81C, NULL, NULL},
	{"_getsystime", 0x00039671, NULL, NULL},
	{"_getw", 0x0002F137, NULL, NULL},
	{"_getwch", 0x0001ECF6, NULL, NULL},
	{"_getwche", 0x0001ED1A, NULL, NULL},
	{"_getws", 0x0002F1B9, NULL, NULL},
	{"_global_unwind2", 0x0002544C, NULL, NULL},
	{"_gmtime64", 0x00039743, NULL, NULL},
	{"_heapadd", 0x0001BC9F, NULL, NULL},
	{"_heapchk", 0x0001BCB3, NULL, NULL},
	{"_heapmin", 0x0001BD8C, NULL, NULL},
	{"_heapset", 0x0001BD82, NULL, NULL},
	{"_heapused", 0x0001BE3A, NULL, NULL},
	{"_heapwalk", 0x0001BE4D, NULL, NULL},
	{"_hypot", 0x0003E6C2, NULL, NULL},
	{"_i64toa", 0x0000C2E1, NULL, NULL},
	{"_i64tow", 0x0000C489, NULL, NULL},
	{"_initterm", 0x00029D67, NULL, NULL},
	{"_inp", 0x0001ED70, NULL, NULL},
	{"_inpd", 0x0001ED81, NULL, NULL},
	{"_inpw", 0x0001ED79, NULL, NULL},
	{"_iob", 0x0004FC80, NULL, NULL},
	{"_isatty", 0x0001ED8D, NULL, NULL},
	{"_isctype", 0x0000C561, NULL, NULL},
	{"_ismbbalnum", 0x00020A3C, NULL, NULL},
	{"_ismbbalpha", 0x00020A5A, NULL, NULL},
	{"_ismbbgraph", 0x00020A78, NULL, NULL},
	{"_ismbbkalnum", 0x000209EB, NULL, NULL},
	{"_ismbbkana", 0x00020B05, NULL, NULL},
	{"_ismbbkprint", 0x00020A06, NULL, NULL},
	{"_ismbbkpunct", 0x00020A21, NULL, NULL},
	{"_ismbblead", 0x00020ACF, NULL, NULL},
	{"_ismbbprint", 0x00020A96, NULL, NULL},
	{"_ismbbpunct", 0x00020AB4, NULL, NULL},
	{"_ismbbtrail", 0x00020AEA, NULL, NULL},
	{"_ismbcalnum", 0x00020B37, NULL, NULL},
	{"_ismbcalpha", 0x00020BD1, NULL, NULL},
	{"_ismbcdigit", 0x00020C6B, NULL, NULL},
	{"_ismbcgraph", 0x00020CF6, NULL, NULL},
	{"_ismbchira", 0x00020D90, NULL, NULL},
	{"_ismbckata", 0x00020DC1, NULL, NULL},
	{"_ismbcl0", 0x00020E35, NULL, NULL},
	{"_ismbcl1", 0x00020E8A, NULL, NULL},
	{"_ismbcl2", 0x00020EE7, NULL, NULL},
	{"_ismbclegal", 0x00020F44, NULL, NULL},
	{"_ismbclower", 0x00020F87, NULL, NULL},
	{"_ismbcprint", 0x00021018, NULL, NULL},
	{"_ismbcpunct", 0x000210B2, NULL, NULL},
	{"_ismbcspace", 0x00021148, NULL, NULL},
	{"_ismbcsymbol", 0x00020DFB, NULL, NULL},
	{"_ismbcupper", 0x000211D3, NULL, NULL},
	{"_ismbslead", 0x000212A8, NULL, NULL},
	{"_ismbstrail", 0x000212D8, NULL, NULL},
	{"_isnan", 0x0003EB3D, NULL, NULL},
	{"_itoa", 0x0000C1F3, NULL, NULL},
	{"_itow", 0x0000C392, NULL, NULL},
	{"_j0", 0x0003FA90, NULL, NULL},
	{"_j1", 0x0003FB8A, NULL, NULL},
	{"_jn", 0x0003FCA4, NULL, NULL},
	{"_kbhit", 0x0001EAE7, NULL, NULL},
	{"_lfind", 0x00025D9A, NULL, NULL},
	{"_loaddll", 0x000186E8, NULL, NULL},
	{"_local_unwind2", 0x000254A7, NULL, NULL},
	{"_localtime64", 0x0003996F, NULL, NULL},
	{"_lock", 0x0002A5BB, NULL, NULL},
	{"_locking", 0x0001EE84, NULL, NULL},
	{"_logb", 0x0003E782, NULL, NULL},
	{"_longjmpex", 0x00025DD4, NULL, NULL},
	{"_lrotl", 0x00025DDE, NULL, NULL},
	{"_lrotr", 0x00025E02, NULL, NULL},
	{"_lsearch", 0x00025E26, NULL, NULL},
	{"_lseek", 0x0001EFB0, NULL, NULL},
	{"_lseeki64", 0x0001F0EA, NULL, NULL},
	{"_ltoa", 0x0000C222, NULL, NULL},
	{"_ltow", 0x0000C3C1, NULL, NULL},
	{"_makepath", 0x00025E76, NULL, NULL},
	{"_mbbtombc", 0x0002132C, NULL, NULL},
	{"_mbbtype", 0x0002146F, NULL, NULL},
	{"_mbcasemap", 0x00052680, NULL, NULL},
	{"_mbccpy", 0x0002149F, NULL, NULL},
	{"_mbcjistojms", 0x000214C7, NULL, NULL},
	{"_mbcjmstojis", 0x00021534, NULL, NULL},
	{"_mbclen", 0x000215E8, NULL, NULL},
	{"_mbctohira", 0x00021608, NULL, NULL},
	{"_mbctokata", 0x00021644, NULL, NULL},
	{"_mbctolower", 0x00021671, NULL, NULL},
	{"_mbctombb", 0x0002139E, NULL, NULL},
	{"_mbctoupper", 0x000216FD, NULL, NULL},
	{"_mbctype", 0x00052560, NULL, NULL},
	{"_mbsbtype", 0x000217CF, NULL, NULL},
	{"_mbscat", 0x00036040, NULL, NULL},
	{"_mbschr", 0x000217FF, NULL, NULL},
	{"_mbscmp", 0x00021881, NULL, NULL},
	{"_mbscoll", 0x00021944, NULL, NULL},
	{"_mbscpy", 0x00036030, NULL, NULL},
	{"_mbscspn", 0x00021A0B, NULL, NULL},
	{"_mbsdec", 0x00021A3B, NULL, NULL},
	{"_mbsdup", 0x00036125, NULL, NULL},
	{"_mbsicmp", 0x00021AA3, NULL, NULL},
	{"_mbsicoll", 0x00021BF5, NULL, NULL},
	{"_mbsinc", 0x00021C3E, NULL, NULL},
	{"_mbslen", 0x00021C5F, NULL, NULL},
	{"_mbslwr", 0x00021CBA, NULL, NULL},
	{"_mbsnbcat", 0x00021D46, NULL, NULL},
	{"_mbsnbcmp", 0x00021E1D, NULL, NULL},
	{"_mbsnbcnt", 0x00021F38, NULL, NULL},
	{"_mbsnbcoll", 0x00021F68, NULL, NULL},
	{"_mbsnbcpy", 0x00021FBD, NULL, NULL},
	{"_mbsnbicmp", 0x00022057, NULL, NULL},
	{"_mbsnbicoll", 0x000221CD, NULL, NULL},
	{"_mbsnbset", 0x00022222, NULL, NULL},
	{"_mbsncat", 0x0002229D, NULL, NULL},
	{"_mbsnccnt", 0x00022360, NULL, NULL},
	{"_mbsncmp", 0x000223B7, NULL, NULL},
	{"_mbsncoll", 0x00022463, NULL, NULL},
	{"_mbsncpy", 0x000224D4, NULL, NULL},
	{"_mbsnextc", 0x00022563, NULL, NULL},
	{"_mbsnicmp", 0x0002258B, NULL, NULL},
	{"_mbsnicoll", 0x000226D8, NULL, NULL},
	{"_mbsninc", 0x00022749, NULL, NULL},
	{"_mbsnset", 0x0002276F, NULL, NULL},
	{"_mbspbrk", 0x000228D3, NULL, NULL},
	{"_mbsrchr", 0x00022903, NULL, NULL},
	{"_mbsrev", 0x00022975, NULL, NULL},
	{"_mbsset", 0x000229E8, NULL, NULL},
	{"_mbsspn", 0x00022AC4, NULL, NULL},
	{"_mbsspnp", 0x00022B80, NULL, NULL},
	{"_mbsstr", 0x00022BB0, NULL, NULL},
	{"_mbstok", 0x00022C70, NULL, NULL},
	{"_mbstrlen", 0x0000C591, NULL, NULL},
	{"_mbsupr", 0x00022D22, NULL, NULL},
	{"_memccpy", 0x00036170, NULL, NULL},
	{"_memicmp", 0x000361C8, NULL, NULL},
	{"_mkdir", 0x0000F827, NULL, NULL},
	{"_mktemp", 0x0001F1AD, NULL, NULL},
	{"_mktime64", 0x00039DCE, NULL, NULL},
	{"_msize", 0x0001BF6C, NULL, NULL},
	{"_nextafter", 0x0003E874, NULL, NULL},
	{"_onexit", 0x00024DF8, NULL, NULL},
	{"_open", 0x0001F566, NULL, NULL},
	{"_open_osfhandle", 0x0001E6B2, NULL, NULL},
	{"_osplatform", 0x00051A14, NULL, NULL},
	{"_osver", 0x00051A18, NULL, NULL},
	{"_outp", 0x0001F620, NULL, NULL},
	{"_outpd", 0x0001F63A, NULL, NULL},
	{"_outpw", 0x0001F62D, NULL, NULL},
	{"_pclose", 0x0002F6DD, NULL, NULL},
	{"_pctype", 0x0004F988, NULL, NULL},
	{"_pgmptr", 0x00051A44, NULL, NULL},
	{"_pipe", 0x0001F64A, NULL, NULL},
	{"_popen", 0x0002F290, NULL, NULL},
	{"_purecall", 0x00025F0D, NULL, NULL},
	{"_putch", 0x0001F894, NULL, NULL},
	{"_putenv", 0x00025FCC, NULL, NULL},
	{"_putw", 0x0002F771, NULL, NULL},
	{"_putwch", 0x0001D3CA, NULL, NULL},
	{"_putws", 0x0002F7F6, NULL, NULL},
	{"_pwctype", 0x0004F98C, NULL, NULL},
	{"_read", 0x0001FAA3, NULL, NULL},
	{"_resetstkoflw", 0x0001C03F, NULL, NULL},
	{"_rmdir", 0x0000F85E, NULL, NULL},
	{"_rmtmp", 0x0002F88A, NULL, NULL},
	{"_rotl", 0x00025DDE, NULL, NULL},
	{"_rotr", 0x00025E02, NULL, NULL},
	{"_safe_fdiv", 0x0003DE8C, NULL, NULL},
	{"_safe_fdivr", 0x0003DEA1, NULL, NULL},
	{"_safe_fprem", 0x0003E429, NULL, NULL},
	{"_safe_fprem1", 0x0003E42F, NULL, NULL},
	{"_scalb", 0x0003E763, NULL, NULL},
	{"_scprintf", 0x0002F990, NULL, NULL},
	{"_scwprintf", 0x0002FA3E, NULL, NULL},
	{"_searchenv", 0x00026010, NULL, NULL},
	{"_seh_longjmp_unwind", 0x00025D7A, NULL, NULL},
	{"_set_SSE2_enable", 0x00040265, NULL, NULL},
	{"_set_error_mode", 0x00025348, NULL, NULL},
	{"_set_sbh_threshold", 0x0001B6E0, NULL, NULL},
	{"_seterrormode", 0x0000E890, NULL, NULL},
	{"_setjmp", 0x0002615C, NULL, NULL},
	{"_setjmp3", 0x0002619C, NULL, NULL},
	{"_setmaxstdio", 0x0002F02C, NULL, NULL},
	{"_setmbcp", 0x0002084D, NULL, NULL},
	{"_setmode", 0x0001FBC7, NULL, NULL},
	{"_setsystime", 0x000396D3, NULL, NULL},
	{"_sleep", 0x0000E0E8, NULL, NULL},
	{"_snprintf", 0x0002FA76, NULL, NULL},
	{"_snscanf", 0x0002FAD4, NULL, NULL},
	{"_snwprintf", 0x0002FB0C, NULL, NULL},
	{"_snwscanf", 0x0002FB83, NULL, NULL},
	{"_sopen", 0x0001F5C0, NULL, NULL},
	{"_spawnl", 0x0001871F, NULL, NULL},
	{"_spawnle", 0x0001873F, NULL, NULL},
	{"_spawnlp", 0x0001876B, NULL, NULL},
	{"_spawnlpe", 0x00018789, NULL, NULL},
	{"_spawnv", 0x000187B5, NULL, NULL},
	{"_spawnve", 0x0001882E, NULL, NULL},
	{"_spawnvp", 0x000189C5, NULL, NULL},
	{"_spawnvpe", 0x000189E4, NULL, NULL},
	{"_splitpath", 0x0002621C, NULL, NULL},
	{"_stat", 0x0000F959, NULL, NULL},
	{"_stat64", 0x0000FCA2, NULL, NULL},
	{"_stati64", 0x000100A8, NULL, NULL},
	{"_statusfp", 0x0003EDC0, NULL, NULL},
	{"_strcmpi", 0x0003624E, NULL, NULL},
	{"_strdate", 0x00039DE5, NULL, NULL},
	{"_strdup", 0x00036125, NULL, NULL},
	{"_strerror", 0x00026372, NULL, NULL},
	{"_stricmp", 0x0003624E, NULL, NULL},
	{"_stricoll", 0x000362BE, NULL, NULL},
	{"_strlwr", 0x00036320, NULL, NULL},
	{"_strncoll", 0x0003643F, NULL, NULL},
	{"_strnicmp", 0x000364BF, NULL, NULL},
	{"_strnicoll", 0x00036545, NULL, NULL},
	{"_strnset", 0x000365D0, NULL, NULL},
	{"_strrev", 0x00036600, NULL, NULL},
	{"_strset", 0x00036640, NULL, NULL},
	{"_strtime", 0x00039E5C, NULL, NULL},
	{"_strtoi64", 0x0000C877, NULL, NULL},
	{"_strtoui64", 0x0000C896, NULL, NULL},
	{"_strupr", 0x00036665, NULL, NULL},
	{"_swab", 0x0000C8B5, NULL, NULL},
	{"_sys_errlist", 0x0004F9D8, NULL, NULL},
	{"_sys_nerr", 0x0004FA88, NULL, NULL},
	{"_tell", 0x0001FC63, NULL, NULL},
	{"_telli64", 0x0001FC7E, NULL, NULL},
	{"_tempnam", 0x0002FC13, NULL, NULL},
	{"_time64", 0x00039ECA, NULL, NULL},
	{"_timezone", 0x0004FFD0, NULL, NULL},
	{"_tolower", 0x0000C8E8, NULL, NULL},
	{"_toupper", 0x0000C9F5, NULL, NULL},
	{"_tzname", 0x00050060, NULL, NULL},
	{"_tzset", 0x0003A541, NULL, NULL},
	{"_ui64toa", 0x0000C319, NULL, NULL},
	{"_ui64tow", 0x0000C4C1, NULL, NULL},
	{"_ultoa", 0x0000C24E, NULL, NULL},
	{"_ultow", 0x0000C3ED, NULL, NULL},
	{"_umask", 0x0002645B, NULL, NULL},
	{"_ungetch", 0x0001EA76, NULL, NULL},
	{"_ungetwch", 0x0001ED3E, NULL, NULL},
	{"_unlink", 0x0001043E, NULL, NULL},
	{"_unloaddll", 0x000186FD, NULL, NULL},
	{"_unlock", 0x0002A519, NULL, NULL},
	{"_utime", 0x0003949E, NULL, NULL},
	{"_utime64", 0x00039631, NULL, NULL},
	{"_vscprintf", 0x0002FEA7, NULL, NULL},
	{"_vscwprintf", 0x0002FF53, NULL, NULL},
	{"_vsnprintf", 0x0002FF8A, NULL, NULL},
	{"_vsnwprintf", 0x0002FFE7, NULL, NULL},
	{"_waccess", 0x0001044E, NULL, NULL},
	{"_wasctime", 0x0003A5A9, NULL, NULL},
	{"_wchdir", 0x0001049E, NULL, NULL},
	{"_wchmod", 0x00010544, NULL, NULL},
	{"_wcmdln", 0x000517A8, NULL, NULL},
	{"_wcreat", 0x0001FC9B, NULL, NULL},
	{"_wcsdup", 0x00036784, NULL, NULL},
	{"_wcserror", 0x0002647B, NULL, NULL},
	{"_wcsicmp", 0x000367BD, NULL, NULL},
	{"_wcsicoll", 0x00036871, NULL, NULL},
	{"_wcslwr", 0x00036917, NULL, NULL},
	{"_wcsncoll", 0x00036A3B, NULL, NULL},
	{"_wcsnicmp", 0x00036ABB, NULL, NULL},
	{"_wcsnicoll", 0x00036B82, NULL, NULL},
	{"_wcsnset", 0x00036C46, NULL, NULL},
	{"_wcsrev", 0x00036C76, NULL, NULL},
	{"_wcsset", 0x00036CB2, NULL, NULL},
	{"_wcstoi64", 0x0000CD5D, NULL, NULL},
	{"_wcstoui64", 0x0000CD7C, NULL, NULL},
	{"_wcsupr", 0x00036CD4, NULL, NULL},
	{"_wctime", 0x0003A690, NULL, NULL},
	{"_wctime64", 0x0003A6B4, NULL, NULL},
	{"_wenviron", 0x00051A3C, NULL, NULL},
	{"_wexecl", 0x00018BA8, NULL, NULL},
	{"_wexecle", 0x00018BC5, NULL, NULL},
	{"_wexeclp", 0x00018BEE, NULL, NULL},
	{"_wexeclpe", 0x00018C08, NULL, NULL},
	{"_wexecv", 0x00018C31, NULL, NULL},
	{"_wexecve", 0x00018CA6, NULL, NULL},
	{"_wexecvp", 0x00018DEA, NULL, NULL},
	{"_wexecvpe", 0x00018E06, NULL, NULL},
	{"_wfdopen", 0x0003005D, NULL, NULL},
	{"_wfindfirst", 0x0000E8A5, NULL, NULL},
	{"_wfindfirst64", 0x0000EA6A, NULL, NULL},
	{"_wfindfirsti64", 0x0000EC83, NULL, NULL},
	{"_wfindnext", 0x0000E98A, NULL, NULL},
	{"_wfindnext64", 0x0000EB79, NULL, NULL},
	{"_wfindnexti64", 0x0000ED89, NULL, NULL},
	{"_wfopen", 0x000301E7, NULL, NULL},
	{"_wfreopen", 0x00030203, NULL, NULL},
	{"_wfsopen", 0x00030186, NULL, NULL},
	{"_wfullpath", 0x0001058E, NULL, NULL},
	{"_wgetcwd", 0x00010740, NULL, NULL},
	{"_wgetdcwd", 0x0001078B, NULL, NULL},
	{"_wgetenv", 0x0002655C, NULL, NULL},
	{"_winmajor", 0x00051A20, NULL, NULL},
	{"_winminor", 0x00051A24, NULL, NULL},
	{"_winver", 0x00051A1C, NULL, NULL},
	{"_wmakepath", 0x000265A0, NULL, NULL},
	{"_wmkdir", 0x000107D7, NULL, NULL},
	{"_wmktemp", 0x0001FCBA, NULL, NULL},
	{"_wopen", 0x00020055, NULL, NULL},
	{"_wperror", 0x00026658, NULL, NULL},
	{"_wpgmptr", 0x00051A48, NULL, NULL},
	{"_wpopen", 0x0003026E, NULL, NULL},
	{"_wputenv", 0x00026811, NULL, NULL},
	{"_wremove", 0x0001080E, NULL, NULL},
	{"_wrename", 0x00010853, NULL, NULL},
	{"_write", 0x00020303, NULL, NULL},
	{"_wrmdir", 0x0001088B, NULL, NULL},
	{"_wsearchenv", 0x00026855, NULL, NULL},
	{"_wsetlocale", 0x00026990, NULL, NULL},
	{"_wsopen", 0x000200AF, NULL, NULL},
	{"_wspawnl", 0x00018F5E, NULL, NULL},
	{"_wspawnle", 0x00018F7E, NULL, NULL},
	{"_wspawnlp", 0x00018FAA, NULL, NULL},
	{"_wspawnlpe", 0x00018FC8, NULL, NULL},
	{"_wspawnv", 0x00018FF4, NULL, NULL},
	{"_wspawnve", 0x0001906D, NULL, NULL},
	{"_wspawnvp", 0x000191B7, NULL, NULL},
	{"_wspawnvpe", 0x000191D6, NULL, NULL},
	{"_wsplitpath", 0x00026A51, NULL, NULL},
	{"_wstat", 0x0001098C, NULL, NULL},
	{"_wstat64", 0x00010D65, NULL, NULL},
	{"_wstati64", 0x000110EB, NULL, NULL},
	{"_wstrdate", 0x0003A6D8, NULL, NULL},
	{"_wstrtime", 0x0003A75C, NULL, NULL},
	{"_wsystem", 0x0001931E, NULL, NULL},
	{"_wtempnam", 0x00030697, NULL, NULL},
	{"_wtmpnam", 0x00030931, NULL, NULL},
	{"_wtof", 0x0000CD9B, NULL, NULL},
	{"_wtoi", 0x0000CEE3, NULL, NULL},
	{"_wtoi64", 0x0000CEF3, NULL, NULL},
	{"_wtol", 0x0000CE77, NULL, NULL},
	{"_wunlink", 0x00010843, NULL, NULL},
	{"_wutime", 0x0003A7DA, NULL, NULL},
	{"_wutime64", 0x0003A81A, NULL, NULL},
	{"_y0", 0x0003FE69, NULL, NULL},
	{"_y1", 0x0003FF9C, NULL, NULL},
	{"_yn", 0x000400DF, NULL, NULL},
	{"abort", 0x00026BB3, NULL, NULL},
	{"abs", 0x00026BD0, NULL, NULL},
	{"acos", 0x0003CA54, NULL, NULL},
	{"asctime", 0x0003A85A, NULL, NULL},
	{"asin", 0x0003CB24, NULL, NULL},
	{"atan", 0x0003CBE0, NULL, NULL},
	{"atan2", 0x0003CD00, NULL, NULL},
	{"atexit", 0x00024E35, NULL, NULL},
	{"atof", 0x0000CF90, NULL, NULL},
	{"atoi", 0x0000BF18, NULL, NULL},
	{"atol", 0x0000BE7B, NULL, NULL},
	{"bsearch", 0x00026BE5, NULL, NULL},
	{"calloc", 0x0001C0C3, NULL, NULL},
	{"ceil", 0x00040290, NULL, NULL},
	{"clearerr", 0x000309F1, NULL, NULL},
	{"clock", 0x0003A969, NULL, NULL},
	{"cos", 0x0003CD34, NULL, NULL},
	{"cosh", 0x0003CDEA, NULL, NULL},
	{"ctime", 0x0003A9F1, NULL, NULL},
	{"difftime", 0x0003AA15, NULL, NULL},
	{"div", 0x00026D46, NULL, NULL},
	{"exit", 0x00029E7E, NULL, NULL},
	{"exp", 0x0003CE20, NULL, NULL},
	{"fabs", 0x000403B2, NULL, NULL},
	{"fclose", 0x00030AB1, env_w32_hook_fclose, NULL},
	{"feof", 0x00030B07, NULL, NULL},
	{"ferror", 0x00030B1C, NULL, NULL},
	{"fflush", 0x0002EEF6, NULL, NULL},
	{"fgetc", 0x00030B31, NULL, NULL},
	{"fgetpos", 0x00030B86, NULL, NULL},
	{"fgets", 0x00030BB1, NULL, NULL},
	{"fgetwc", 0x00030D37, NULL, NULL},
	{"fgetws", 0x00030D8E, NULL, NULL},
	{"floor", 0x00040470, NULL, NULL},
	{"fmod", 0x0003CEB0, NULL, NULL},
	{"fopen", 0x0002F010, env_w32_hook_fopen, NULL},
	{"fprintf", 0x00030E13, NULL, NULL},
	{"fputc", 0x00030E76, NULL, NULL},
	{"fputs", 0x00030ED3, NULL, NULL},
	{"fputwc", 0x0003102C, NULL, NULL},
	{"fputws", 0x00031089, NULL, NULL},
	{"fread", 0x000311FB, NULL, NULL},
	{"free", 0x0001C21B, NULL, NULL},
	{"freopen", 0x0003124C, NULL, NULL},
	{"frexp", 0x00040596, NULL, NULL},
	{"fscanf", 0x000312B7, NULL, NULL},
	{"fseek", 0x0003139C, NULL, NULL},
	{"fsetpos", 0x000313EA, NULL, NULL},
	{"ftell", 0x00031574, NULL, NULL},
	{"fwprintf", 0x000315BA, NULL, NULL},
	{"fwrite", 0x0003173B, env_w32_hook_fwrite, NULL},
	{"fwscanf", 0x0003178C, NULL, NULL},
	{"getc", 0x00030B31, NULL, NULL},
	{"getchar", 0x0002EB3B, NULL, NULL},
	{"getenv", 0x00026D02, NULL, NULL},
	{"gets", 0x000317DB, NULL, NULL},
	{"getwc", 0x00030D7E, NULL, NULL},
	{"getwchar", 0x0002EB56, NULL, NULL},
	{"gmtime", 0x0003AA2D, NULL, NULL},
	{"is_wctype", 0x0000D090, NULL, NULL},
	{"isalnum", 0x0000BCEB, NULL, NULL},
	{"isalpha", 0x0000BB05, NULL, NULL},
	{"iscntrl", 0x0000BDC6, NULL, NULL},
	{"isdigit", 0x0000BBD6, NULL, NULL},
	{"isgraph", 0x0000BD7D, NULL, NULL},
	{"isleadbyte", 0x0000D0A0, NULL, NULL},
	{"islower", 0x0000BB92, NULL, NULL},
	{"isprint", 0x0000BD34, NULL, NULL},
	{"ispunct", 0x0000BCA7, NULL, NULL},
	{"isspace", 0x0000BC63, NULL, NULL},
	{"isupper", 0x0000BB4E, NULL, NULL},
	{"iswalnum", 0x0000D16D, NULL, NULL},
	{"iswalpha", 0x0000D0BF, NULL, NULL},
	{"iswascii", 0x0000D1D6, NULL, NULL},
	{"iswcntrl", 0x0000D1BE, NULL, NULL},
	{"iswctype", 0x0000D036, NULL, NULL},
	{"iswdigit", 0x0000D10A, NULL, NULL},
	{"iswgraph", 0x0000D1A3, NULL, NULL},
	{"iswlower", 0x0000D0F2, NULL, NULL},
	{"iswprint", 0x0000D188, NULL, NULL},
	{"iswpunct", 0x0000D155, NULL, NULL},
	{"iswspace", 0x0000D13D, NULL, NULL},
	{"iswupper", 0x0000D0DA, NULL, NULL},
	{"iswxdigit", 0x0000D122, NULL, NULL},
	{"isxdigit", 0x0000BC1A, NULL, NULL},
	{"labs", 0x00026BD0, NULL, NULL},
	{"ldexp", 0x00040649, NULL, NULL},
	{"ldiv", 0x00026D46, NULL, NULL},
	{"localeconv", 0x00026D67, NULL, NULL},
	{"localtime", 0x0003AB3D, NULL, NULL},
	{"log", 0x0003CEE0, NULL, NULL},
	{"log10", 0x0003D040, NULL, NULL},
	{"longjmp", 0x00026D74, NULL, NULL},
	{"malloc", 0x0001C407, env_w32_hook_malloc, NULL},
	{"mblen", 0x0000D1EC, NULL, NULL},
	{"mbstowcs", 0x0000D380, NULL, NULL},
	{"mbtowc", 0x0000D47A, NULL, NULL},
	{"memchr", 0x00036E00, NULL, NULL},
	{"memcmp", 0x00036EB0, NULL, NULL},
	{"memcpy", 0x00036F70, NULL, NULL},
	{"memmove", 0x000372B0, NULL, NULL},
	{"memset", 0x000375F0, env_w32_hook_memset, NULL},
	{"mktime", 0x0003AE8C, NULL, NULL},
	{"modf", 0x00040840, NULL, NULL},
	{"perror", 0x00026DF2, NULL, NULL},
	{"pow", 0x0003D1A0, NULL, NULL},
	{"printf", 0x0003186A, NULL, NULL},
	{"putc", 0x00030E76, NULL, NULL},
	{"putchar", 0x0002EF74, NULL, NULL},
	{"puts", 0x000318D5, NULL, NULL},
	{"putwc", 0x00031079, NULL, NULL},
	{"putwchar", 0x0002EF9F, NULL, NULL},
	{"qsort", 0x00026F50, NULL, NULL},
	{"raise", 0x0002518D, NULL, NULL},
	{"rand", 0x000271D3, NULL, NULL},
	{"realloc", 0x0001C437, NULL, NULL},
	{"remove", 0x00010409, NULL, NULL},
	{"rename", 0x0001144A, NULL, NULL},
	{"rewind", 0x00031983, NULL, NULL},
	{"scanf", 0x00031A11, NULL, NULL},
	{"setbuf", 0x00031A6A, NULL, NULL},
	{"setlocale", 0x00023C31, NULL, NULL},
	{"setvbuf", 0x00031A97, NULL, NULL},
	{"signal", 0x00024FD4, NULL, NULL},
	{"sin", 0x0003D444, NULL, NULL},
	{"sinh", 0x0003CDE0, NULL, NULL},
	{"sprintf", 0x0002F931, NULL, NULL},
	{"sqrt", 0x0003D504, NULL, NULL},
	{"srand", 0x000271BC, NULL, NULL},
	{"sscanf", 0x00031B72, NULL, NULL},
	{"strcat", 0x00036040, NULL, NULL},
	{"strchr", 0x00037660, NULL, NULL},
	{"strcmp", 0x00037730, NULL, NULL},
	{"strcoll", 0x000377B9, NULL, NULL},
	{"strcpy", 0x00036030, NULL, NULL},
	{"strcspn", 0x00037850, NULL, NULL},
	{"strerror", 0x000271FA, NULL, NULL},
	{"strftime", 0x000390CD, NULL, NULL},
	{"strlen", 0x000378A0, NULL, NULL},
	{"strncat", 0x00037920, NULL, NULL},
	{"strncmp", 0x00037A50, NULL, NULL},
	{"strncpy", 0x00037A90, NULL, NULL},
	{"strpbrk", 0x00037BA0, NULL, NULL},
	{"strrchr", 0x00037BE0, NULL, NULL},
	{"strspn", 0x00037C10, NULL, NULL},
	{"strstr", 0x00037C60, NULL, NULL},
	{"strtod", 0x0000D4AD, NULL, NULL},
	{"strtok", 0x00037CE5, NULL, NULL},
	{"strtol", 0x0000D711, NULL, NULL},
	{"strtoul", 0x0000D730, NULL, NULL},
	{"strxfrm", 0x00037DA7, NULL, NULL},
	{"swprintf", 0x0002F9C8, NULL, NULL},
	{"swscanf", 0x00031BB3, NULL, NULL},
	{"system", 0x000193C7, NULL, NULL},
	{"tan", 0x0003D5C4, NULL, NULL},
	{"tanh", 0x0003CDF1, NULL, NULL},
	{"time", 0x0003AEA3, NULL, NULL},
	{"tmpfile", 0x00031D8F, NULL, NULL},
	{"tmpnam", 0x00031CBF, NULL, NULL},
	{"tolower", 0x0000C9C9, NULL, NULL},
	{"toupper", 0x0000CAD7, NULL, NULL},
	{"towlower", 0x0000D7B7, NULL, NULL},
	{"towupper", 0x0000D877, NULL, NULL},
	{"ungetc", 0x00031F23, NULL, NULL},
	{"ungetwc", 0x00032084, NULL, NULL},
	{"vfprintf", 0x000320CF, NULL, NULL},
	{"vfwprintf", 0x00032131, NULL, NULL},
	{"vprintf", 0x00032193, NULL, NULL},
	{"vsprintf", 0x0002FE49, NULL, NULL},
	{"vswprintf", 0x0002FEDE, NULL, NULL},
	{"vwprintf", 0x000321F7, NULL, NULL},
	{"wcscat", 0x00037E61, NULL, NULL},
	{"wcschr", 0x00037EB8, NULL, NULL},
	{"wcscmp", 0x00037EE3, NULL, NULL},
	{"wcscoll", 0x00037F1F, NULL, NULL},
	{"wcscpy", 0x00037E94, NULL, NULL},
	{"wcscspn", 0x00037F81, NULL, NULL},
	{"wcsftime", 0x0003AEE3, NULL, NULL},
	{"wcslen", 0x00037FCC, NULL, NULL},
	{"wcsncat", 0x00037FEB, NULL, NULL},
	{"wcsncmp", 0x0003802F, NULL, NULL},
	{"wcsncpy", 0x0003806B, NULL, NULL},
	{"wcspbrk", 0x000380B0, NULL, NULL},
	{"wcsrchr", 0x000380F9, NULL, NULL},
	{"wcsspn", 0x00038132, NULL, NULL},
	{"wcsstr", 0x00038180, NULL, NULL},
	{"wcstod", 0x0000D8C5, NULL, NULL},
	{"wcstok", 0x000381E6, NULL, NULL},
	{"wcstol", 0x0000DC2B, NULL, NULL},
	{"wcstombs", 0x0000DE16, NULL, NULL},
	{"wcstoul", 0x0000DC4A, NULL, NULL},
	{"wcsxfrm", 0x00038292, NULL, NULL},
	{"wctomb", 0x0000DEB0, NULL, NULL},
	{"wprintf", 0x0003225B, NULL, NULL},
	{"wscanf", 0x000322C6, NULL, NULL},
	{0, 0, NULL}
};


struct emu_env_w32_dll_export urlmon_exports[] = 
{
	{ "AsyncGetClassBits", 0x0003DF95, NULL, NULL},
	{ "AsyncInstallDistributionUnit", 0x0003DA19, NULL, NULL},
	{ "BindAsyncMoniker", 0x0002C9CF, NULL, NULL},
	{ "CDLGetLongPathNameA", 0x0003E4A5, NULL, NULL},
	{ "CDLGetLongPathNameW", 0x0003E4D0, NULL, NULL},
	{ "CoGetClassObjectFromURL", 0x0003DBF3, NULL, NULL},
	{ "CoInstall", 0x0003C747, NULL, NULL},
	{ "CoInternetCombineUrl", 0x00016459, NULL, NULL},
	{ "CoInternetCompareUrl", 0x0002E83F, NULL, NULL},
	{ "CoInternetCreateSecurityManager", 0x000030E7, NULL, NULL},
	{ "CoInternetCreateZoneManager", 0x00009BE7, NULL, NULL},
	{ "CoInternetFeatureSettingsChanged", 0x0005DFEF, NULL, NULL},
	{ "CoInternetGetProtocolFlags", 0x00054F4C, NULL, NULL},
	{ "CoInternetGetSecurityUrl", 0x0000455E, NULL, NULL},
	{ "CoInternetGetSession", 0x0000CB90, NULL, NULL},
	{ "CoInternetIsFeatureEnabled", 0x000027C0, NULL, NULL},
	{ "CoInternetIsFeatureEnabledForUrl", 0x0000BB5E, NULL, NULL},
	{ "CoInternetIsFeatureZoneElevationEnabled", 0x0002F48F, NULL, NULL},
	{ "CoInternetParseUrl", 0x0000CEAC, NULL, NULL},
	{ "CoInternetQueryInfo", 0x00015DEF, NULL, NULL},
	{ "CoInternetSetFeatureEnabled", 0x0002F5ED, NULL, NULL},
	{ "CompareSecurityIds", 0x00033BD0, NULL, NULL},
	{ "CompatFlagsFromClsid", 0x00016BB3, NULL, NULL},
	{ "CopyBindInfo", 0x000107E4, NULL, NULL},
	{ "CopyStgMedium", 0x000108A7, NULL, NULL},
	{ "CreateAsyncBindCtx", 0x00019C24, NULL, NULL},
	{ "CreateAsyncBindCtxEx", 0x00015D58, NULL, NULL},
	{ "CreateFormatEnumerator", 0x00018353, NULL, NULL},
	{ "CreateURLMoniker", 0x0000D381, NULL, NULL},
	{ "CreateURLMonikerEx", 0x0000D39F, NULL, NULL},
	{ "DllCanUnloadNow", 0x00002EEC, NULL, NULL},
	{ "DllGetClassObject", 0x00006042, NULL, NULL},
	{ "DllInstall", 0x0002CE5C, NULL, NULL},
	{ "DllRegisterServer", 0x0002CB45, NULL, NULL},
	{ "DllRegisterServerEx", 0x0002CE51, NULL, NULL},
	{ "DllUnregisterServer", 0x0002CCDD, NULL, NULL},
	{ "Extract", 0x0003EAC5, NULL, NULL},
	{ "FaultInIEFeature", 0x00017648, NULL, NULL},
	{ "FindMediaType", 0x00012AEB, NULL, NULL},
	{ "FindMediaTypeClass", 0x000182D9, NULL, NULL},
	{ "FindMimeFromData", 0x0002E810, NULL, NULL},
	{ "GetClassFileOrMime", 0x0002EED3, NULL, NULL},
	{ "GetClassURL", 0x000369FD, NULL, NULL},
	{ "GetComponentIDFromCLSSPEC", 0x0003F2DF, NULL, NULL},
	{ "GetMarkOfTheWeb", 0x0005F3DD, NULL, NULL},
	{ "GetSoftwareUpdateInfo", 0x00043A4A, NULL, NULL},
	{ "HlinkGoBack", 0x0005927C, NULL, NULL},
	{ "HlinkGoForward", 0x000592FA, NULL, NULL},
	{ "HlinkNavigateMoniker", 0x00059B99, NULL, NULL},
	{ "HlinkNavigateString", 0x00059C1D, NULL, NULL},
	{ "HlinkSimpleNavigateToMoniker", 0x00059641, NULL, NULL},
	{ "HlinkSimpleNavigateToString", 0x00059BBA, NULL, NULL},
	{ "InstallFlash", 0x0002CF6E, NULL, NULL},
	{ "IsAsyncMoniker", 0x00015324, NULL, NULL},
	{ "IsJITInProgress", 0x0003F269, NULL, NULL},
	{ "IsLoggingEnabledA", 0x0005B442, NULL, NULL},
	{ "IsLoggingEnabledW", 0x0005B563, NULL, NULL},
	{ "IsValidURL", 0x0001960A, NULL, NULL},
	{ "MkParseDisplayNameEx", 0x0002C834, NULL, NULL},
	{ "ObtainUserAgentString", 0x0003402E, NULL, NULL},
	{ "PrivateCoInstall", 0x0003DB11, NULL, NULL},
	{ "RegisterBindStatusCallback", 0x00015B6F, NULL, NULL},
	{ "RegisterFormatEnumerator", 0x00015BE6, NULL, NULL},
	{ "RegisterMediaTypeClass", 0x0002C772, NULL, NULL},
	{ "RegisterMediaTypes", 0x0002C71A, NULL, NULL},
	{ "ReleaseBindInfo", 0x0000D7B7, NULL, NULL},
	{ "RevokeBindStatusCallback", 0x00015A5E, NULL, NULL},
	{ "RevokeFormatEnumerator", 0x0002C80F, NULL, NULL},
	{ "SetSoftwareUpdateAdvertisementState", 0x00043AAE, NULL, NULL},
	{ "URLDownloadA", 0x0002F0DD, NULL, NULL},
	{ "URLDownloadToCacheFileA", 0x0005B1C1, NULL, NULL},
	{ "URLDownloadToCacheFileW", 0x0005ADA4, NULL, NULL},
	{ "URLDownloadToFileA", 0x0005B0BB, env_w32_hook_URLDownloadToFileA, NULL},
	{ "URLDownloadToFileW", 0x0005AD3E, NULL, NULL},
	{ "URLDownloadW", 0x0002E66E, NULL, NULL},
	{ "URLOpenBlockingStreamA", 0x0005B305, NULL, NULL},
	{ "URLOpenBlockingStreamW", 0x0005AF4D, NULL, NULL},
	{ "URLOpenPullStreamA", 0x0005B024, NULL, NULL},
	{ "URLOpenPullStreamW", 0x0005ACF4, NULL, NULL},
	{ "URLOpenStreamA", 0x0005B3AB, NULL, NULL},
	{ "URLOpenStreamW", 0x0005AFDA, NULL, NULL},
	{ "UrlMkBuildVersion", 0x0002CE6C, NULL, NULL},
	{ "UrlMkGetSessionOption", 0x000149A9, NULL, NULL},
	{ "UrlMkSetSessionOption", 0x0002E4EF, NULL, NULL},
	{ "WriteHitLogging", 0x0005B4AA, NULL, NULL},
	{ "ZonesReInit", 0x0005F38C, NULL, NULL},
	{ 0, 0, NULL, NULL},
};

